var LeetKeyEditorHandlers = {

	handleArrayOut : function(str) {
		if (str.length==1) {
			return str.charCodeAt(0);
		}
		var outArray = new Array(str.length);
		for(var i=0;i<str.length;i++) {
			outArray[i] = str.charCodeAt(i);
		}
		return outArray;
	},

	mapLeet : function(ch, isCapital, isShiftOn, event) {
		var str = leetKeyInit.prefLoader.leetKeyMap[String.fromCharCode(ch)];
		return LeetKeyEditorHandlers.handleArrayOut(str);
	},

	mapReverse : function(ch, isCapital, isShiftOn, event) {
		return ch;
	},

	ROT13 : function(ch, isCapital, isShiftOn, event) {
		var chout;
		if ((ch>=65 && ch<78) || (ch>=97 && ch<110)) {
			chout = ch + 13;
		} else if ((ch>77 && ch<=90) || (ch>109 && ch<=122)) {
			chout = ch - 13;
		} else {
			chout = ch;
		}
		return chout;
	},

	urlEncode : function(ch, isCapital, isShiftOn, event) {
		ch = String.fromCharCode(ch);
		var outstr=escape(ch);
		outstr=outstr.replace(new RegExp('\\+','g'),'%2B');
		outstr=outstr.replace(new RegExp('%20','g'),'+');
		return LeetKeyEditorHandlers.handleArrayOut(outstr);
	},

	// HEX STARTS
	digitArray : new Array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'),

	toHex: function (n){
		var result = ''
		var start = true;
		for (var i=32; i>0;){
			i-=4;
			var digit = (n>>i) & 0xf;
			if (!start || digit != 0){
				start = false;
				result += LeetKeyEditorHandlers.digitArray[digit];
			}
		}
		return (result==''?'0':result);
	},
	
	pad: function (str, len, pad){
		var result = str;
		for (var i=str.length; i<len; i++){
			result = pad + result;
		}
		return result;
	},

	encodeHex : function (ch, isCapital, isShiftOn, event){
		var result = LeetKeyEditorHandlers.pad(LeetKeyEditorHandlers.toHex(ch&0xff),2,'0') + " ";
		return LeetKeyEditorHandlers.handleArrayOut(result);
	},
	// HEX ENDS

	// BIN STARTS
	base2Masks : new Array(0x0,0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80),

	toBinString : function (number) {
		var result=new Array("","","","","","","","");
		var i=0;
		for(;i<9;i++) {
			if ((number & LeetKeyEditorHandlers.base2Masks[i]) == LeetKeyEditorHandlers.base2Masks[i]) {
				if(LeetKeyEditorHandlers.base2Masks[i]==0) {
					//result[i]="0";
				} else {
					result[i]="1";
				}
			} else {
				result[i]="0";
			}
		}	
		return result.reverse().join("");
	},

	binEncode : function (ch, isCapital, isShiftOn, event){
		var result = LeetKeyEditorHandlers.toBinString(ch&0xff) + " ";
		return LeetKeyEditorHandlers.handleArrayOut(result);
	},
	// BIN ENDS

	// MORSE STARTS
	morseCodeMap : new Array(
	'.-','-...','-.-.','-..','.','..-.','--.','....','..','.---','-.-','.-..','--','-.','---','.--.','--.-',
	'.-.','...','-','..-','...-','.--','-..-','-.--','--..','-----','.----','..---','...--','....-','.....',
	'-....','--...','---..','----.','.-.-.-','--..--','..--..'),

	encodeMorse : function(ch, isCapital, isShiftOn, event) {
		var chout;
		if (ch>=65 && ch<=90) {
			chout = LeetKeyEditorHandlers.morseCodeMap[ch-65];
		} else if (ch>=97 && ch<=122) {
			chout = LeetKeyEditorHandlers.morseCodeMap[ch-97];
		} else if (ch>=48 && ch<=57) {
			chout = LeetKeyEditorHandlers.morseCodeMap[ch-48+26]
		} else if (ch==46) {
			chout = LeetKeyEditorHandlers.morseCodeMap[36];
		} else if (ch==44) {
			chout = LeetKeyEditorHandlers.morseCodeMap[37];
		} else if (ch==63) {
			chout = LeetKeyEditorHandlers.morseCodeMap[38];
		} else {
			chout = String.fromCharCode(ch);
		}
		return LeetKeyEditorHandlers.handleArrayOut(chout + " ");
	},

	morseKeyUp : function(ch, isCapital, isShiftOn, event) {
		if (ch==32 && !event.ctrlKey && !event.altKey && !event.metaKey) {
			var textNode = LK_TextEditorLib.getTextNode();
			var timediff=0;
			if (textNode.morseTypeStartMS != -1) {
				var currtime = (new Date).getTime();
				timediff = currtime - textNode.morseTypeStartMS;
			}
			var chOut;
			// di time
			if (timediff <= 100) {
				chOut = '.';//46;
			// da time
			} else {
				chOut = '-';//45;
			}
			textNode.morseTypeStartMS = (new Date).getTime();
			return textNode.morseCharDelim + chOut;
		}
		return -1;
	},

	morseKeyPress : function(event) {
		if (event.which==32 && !event.ctrlKey && !event.altKey && !event.metaKey) {
			event.preventDefault();
		}
	},

	morseKeyDown : function(event) {
		if (event.which==32) {
			var timediff=0;
			var outstr;
			var textNode = LK_TextEditorLib.getTextNode();
			if (textNode.morseTypeStartMS != -1) {
				timediff = (new Date).getTime() - textNode.morseTypeStartMS;
			}
			if (timediff <= 320) {
				textNode.morseCharDelim = "";
			} else if (timediff <= 600) {
				textNode.morseCharDelim = " ";
			} else {
				textNode.morseCharDelim = "  ";
			}
			textNode.morseTypeStartMS = (new Date).getTime();
		}
	},
	// MORSE ENDS

	textLoop : function() {
		var textNode = LK_TextEditorLib.getTextNode();
		var ch = leetKeyInit.prefLoader.textLoop.charCodeAt(textNode.textLoopIndex++);
		if (leetKeyInit.prefLoader.textLoop.length==textNode.textLoopIndex) {
			textNode.textLoopIndex=0;
		}
		return ch;
	},

	// DVORAK STARTS
	dvorakKeymapSpecialFunction : new Array(59),
	dvorakKeymapSpecialFunctionPressedWithShift : new Array(95),
	initDvorak : function() {
		for(i=0;i<LeetKeyEditorHandlers.dvorakKeymapSpecialFunction.length;i++) {
			LeetKeyEditorHandlers.dvorakKeymapSpecialFunction[i]=false;
		}
		var dvorakSpecialFunctionCodes="0,8,12,13,16,17,18,19,20,27,33,34,35,36,37,38,40,48,49,50,51,52,53,54,55,56,57,96".split(",");
		for(var i=0;i<dvorakSpecialFunctionCodes.length;i++) {
			LeetKeyEditorHandlers.dvorakKeymapSpecialFunction[parseInt(dvorakSpecialFunctionCodes[i])] = true;
		}
		for(i=0;i<LeetKeyEditorHandlers.dvorakKeymapSpecialFunctionPressedWithShift.length;i++) {
			LeetKeyEditorHandlers.dvorakKeymapSpecialFunctionPressedWithShift[i]=false;
		}
		var dvorakKeymapSpecialFunctionPressedWithShiftCodes="41,42,64,94,126".split(",");
		for(var i=0;i<dvorakKeymapSpecialFunctionPressedWithShiftCodes.length;i++) {
			LeetKeyEditorHandlers.dvorakKeymapSpecialFunctionPressedWithShift[parseInt(dvorakKeymapSpecialFunctionPressedWithShiftCodes[i])] = true;
		}
	},
	dvorakMap : new Array (' ',
		'A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
		'a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
		'[','{',']','}','/','?','=','+','[','{','-','_',';',':','\'','"',',','<','.','>','\\','|'),
	qwertyMap : new Array (' ',
		'A','N','I','H','D','Y','U','J','G','C','V','P','M','L','S','R','X','O',';','K','F','.',',','B','T','/',
		'a','n','i','h','d','y','u','j','g','c','v','p','m','l','s','r','x','o',':','k','f','>','<','b','t','?',
		'-','_','=','+','[','{',']','}','/','?','\'','"','Z','z','Q','q','W','w','E','e','\\','|'),
	dvorakSpecialCharsNoShift : new Array ('\'', ',', '.', ';'),
	dvorakSpecialCharsWithShift : new Array ('"', '<', '>', ':'),
	qwertyCharsForDvorakSpecialChars : new Array ('Q', 'W', 'E', 'Z'),
	dvorak: function(ch, isCapital, isShiftOn, event) {
		if (event.ctrlKey || event.altKey || event.shiftKey && LeetKeyEditorHandlers.dvorakKeymapSpecialFunctionPressedWithShift[ch]) {
			return -1;
		}
		if (LeetKeyEditorHandlers.dvorakKeymapSpecialFunction[ch]==true) {
			return -1;
		}
		var instr = String.fromCharCode(ch);
		var outstr = "";
		var specialCharIndex = -1;
		var chin = instr[0];
		var chout;
		for(var j=0;j<LeetKeyEditorHandlers.qwertyMap.length;j++) {
			if (LeetKeyEditorHandlers.qwertyMap[j]==chin) {
				chout=LeetKeyEditorHandlers.dvorakMap[j];
				var chcode = chout.charCodeAt(0);
				specialCharIndex = -1;
				for (k=0;k<LeetKeyEditorHandlers.qwertyCharsForDvorakSpecialChars.length;k++) {
					var chinUpper = chin.toUpperCase();
					if (chinUpper == LeetKeyEditorHandlers.qwertyCharsForDvorakSpecialChars[k]) {
						specialCharIndex = k;
						break;
					}
				}
				if (specialCharIndex>-1) {
					if (isShiftOn) {
						chout = LeetKeyEditorHandlers.dvorakSpecialCharsWithShift[specialCharIndex]
					} else {
						chout = LeetKeyEditorHandlers.dvorakSpecialCharsNoShift[specialCharIndex];
					}
				} else if (chcode>=65 && chcode <=90) {
					if (!isCapital) {
						chout = chout.toLowerCase();
					}
				} else if (chcode>=97 && chcode <=122) {
					if (isCapital) {
						chout = chout.toUpperCase();
					}
				}
				break;
			}
		}
		if (chout=='undefined') {
			chout = instr;
		}
		return chout.charCodeAt(0);
	}
	// DVORAK ENDS
}