// Leet Key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

var tryUpdatingLeetKey=true;

var LeetKeyInitializer = {

	LeetKeyInitializer : function() {
		this.prefLoader = new LeetkeyPreferenceLoaderLib.LeetkeyPreferenceLoaderLib();
		this.isTranslatorOn = false;

		this.initLeetKey = LeetKeyInitializer.initLeetKey;
		this.onContextMenuPopup = LeetKeyInitializer.onContextMenuPopup;
		this.onContextMenuPopupTB = LeetKeyInitializer.onContextMenuPopupTB;
		this.setupMenuListeners = LeetKeyInitializer.setupMenuListeners;
		this.updateLeetKeyStatusBar = LeetKeyInitializer.updateLeetKeyStatusBar;
		this.updateLeetKeyStatusBarForTranslator = LeetKeyInitializer.updateLeetKeyStatusBarForTranslator;
		this.checkForNewLeetKeyVersion = LeetKeyInitializer.checkForNewLeetKeyVersion;
		this.onUpdateResponse = LeetKeyInitializer.onUpdateResponse;
		this.onUpdateError = LeetKeyInitializer.onUpdateError;
		this.onLoadNewVersion = LeetKeyInitializer.onLoadNewVersion;

		this.initLeetKey();
	},

	onStatusPopup : function() {
/*
		var designMode = gContextMenu.target.parentNode.designMode;
		if (!designMode) {
			designMode = gContextMenu.target.parentNode.parentNode.designMode;
		}
		_iframeDocument = null;
		if (designMode=="on") {
			_iframeDocument = gContextMenu.target;
		}
		gContextMenu.showItem("leetkeyMenu", gContextMenu.isTextSelected || gContextMenu.onTextInput || (gContextMenu.inFrame && designMode=="on"));
*/

		item = document.getElementById("statusmenu-leetkey-toggleeditor");
		if (item != null) {
//consoleDump("statusmenu-leetkey-toggleedit");
			//item.hidden = gContextMenu.isTextSelected;
			item.hidden = false;
		}
	},

	onContextMenuPopup : function() {
		if (!gContextMenu) {
			return;
		}
		var designMode = gContextMenu.target.parentNode.designMode;
		if (!designMode) {
			designMode = gContextMenu.target.parentNode.parentNode.designMode;
		}
		_iframeDocument = null;
		if (designMode=="on") {
			_iframeDocument = gContextMenu.target;
		}
		gContextMenu.showItem("leetkeyMenu", gContextMenu.isTextSelected || gContextMenu.onTextInput || (gContextMenu.inFrame && designMode=="on"));
		item = document.getElementById("contextmenu-leetkey-toggleeditor");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}

		item = document.getElementById("menu-leetkey-toggleeditor");
		if (item != null) {
			item.hidden = gContextMenu.isTextSelected;
		}

	},

	onContextMenuPopupTB : function() {
	},

	initLeetKey : function()
	{
		this.prefLoader.getApplicationContainerType();
		this.prefLoader.loadStrings();
		this.prefLoader.loadPreferences();
		this.setupMenuListeners();
		this.updateLeetKeyStatusBar();
		LeetKey.initializeLeetKey();
		this.checkForNewLeetKeyVersion();
		this.updateLeetKeyStatusBar();
	},

	checkForNewLeetKeyVersion : function() {
		if (tryUpdatingLeetKey && this.prefLoader.tryUpdating && this.prefLoader.updateVersionCounter>LeetkeyPreferenceLoaderLib.versionUpdateCounterRollover-1) {
			tryUpdatingLeetKey = false;
			var updateURL = "http://leetkey.mozdev.org/leetkeyupdate.rdf";
			var request = new XMLHttpRequest();
			request.onload = this.onUpdateResponse;
			request.onerror = this.onUpdateError;
			request.open("GET",updateURL,true);
			request.send(null);
		}
	},

	onUpdateResponse : function(event) {
		var response = event.target;
		if (response.status==200) {
			var rdf = response.responseText;
			var newVersion = LK_parseForText(rdf, "<em:version>", "</em:version>");
			var newVersionURL = LK_parseForText(rdf, "<em:updateLink>", "</em:updateLink>");
			var curVersion = LeetkeyPreferenceLoaderLib.leetKeyVersion;
			var newVersionNum = parseInt(newVersion.replace(/\./g, ""));
			if (newVersionNum!=NaN) {
				var curVersionNum = parseInt(curVersion.replace(/\./g, ""));
				if (newVersionNum > curVersionNum) {
					if (confirm("LeetKey extension has detected a new version " + newVersion + ", press 'OK' to upgrade")) {
						//var fd = new FileDownloader(newVersionURL, newVersion);//fd.start();
						var updater = new LK_XPIUpdateInstaller(newVersionURL, newVersion, "LeetKey");
						updater.initiateUpdate();
					}
				}
			}
		}
	},

	onLoadNewVersion : function(event) {
	},

	onUpdateError : function(event) {
	},

	setupMenuListeners : function() {
		if (this.prefLoader.hostAppId=="FF") {
			var menu = document.getElementById("contentAreaContextMenu");
			if (menu) {
				menu.addEventListener("popupshowing", this.onContextMenuPopup, false);
			}
			if (document.getElementById("menu_EditPopup")){
				document.getElementById("menu_EditPopup").addEventListener("popupshowing", this.onContextMenuPopup, false);
			}
		}	
		if (this.prefLoader.hostAppId=="TB") {
			var menuEdit = document.getElementById("menu_Edit");

			if (menuEdit){
				menuEdit.addEventListener("popupshowing", this.onContextMenuPopupTB, false);
			}
			var menuComp = document.getElementById("msgComposeContext");
			if (menuComp) {
				menuComp.addEventListener("popupshowing", this.onContextMenuPopupTB, false);
			}
			if (document.getElementById("messagePaneContext")){
				document.getElementById("messagePaneContext").addEventListener("popupshowing", this.onContextMenuPopupTB,false);    
			}
			if (document.getElementById("msgComposeContext")){
				document.getElementById("msgComposeContext").addEventListener("popupshowing", this.onContextMenuPopupTB,false);    
			}
		}
	},

	updateLeetKeyStatusBar : function() {
		var leetkeyStatusBarButton = document.getElementById('leetkey-status');
		if(leetkeyStatusBarButton) {
			if (LeetkeyPreferenceLoaderLib.showIcon) {
				leetkeyStatusBarButton.hidden=false;
				this.isTranslatorOn = LK_TextEditorLib.areAnyTextEditorsAttached();
				var leetkeyStatusBarButtonTooltip = document.getElementById('leetkey-tooltip-value');
				var shortCutsTipStr=" (shortcuts: "+this.prefLoader.shortCutString+")";
				if (this.isTranslatorOn) {
					leetkeyStatusBarButton.setAttribute("status", "enabled");
					leetkeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.leetKeyStrings.getString("statusbar-tooltip-enabled")+shortCutsTipStr);
				} else {
					leetkeyStatusBarButton.setAttribute("status", "disabled");
					leetkeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.leetKeyStrings.getString("statusbar-tooltip-disabled")+shortCutsTipStr);
				}

			} else {
				leetkeyStatusBarButton.hidden=true;
			}
		}
	},

	updateLeetKeyStatusBarForTranslator : function() {
		var leetkeyStatusBarButton = document.getElementById('leetkey-status');
		if(leetkeyStatusBarButton)
		{
			if (LeetkeyPreferenceLoaderLib.showIcon) {
				leetkeyStatusBarButton.hidden=false;
				var leetkeyStatusBarButtonTooltip = document.getElementById('leetkey-tooltip-value');
				if (leetkeyStatusBarButton.getAttribute("status")=="translating1") {
					leetkeyStatusBarButton.setAttribute("status", "translating2");
					leetkeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.leetKeyStrings.getString("statusbar-tooltip-translating"));
				} else {
					leetkeyStatusBarButton.setAttribute("status", "translating1");
					leetkeyStatusBarButtonTooltip.setAttribute("value", this.prefLoader.leetKeyStrings.getString("statusbar-tooltip-translating"));
				}
			} else {
				leetkeyStatusBarButton.hidden=true;
			}
		}
	}
}