// Leet Key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

var LeetKeyPreferencesManager = {
	totalShortCuts : 34,
	shortCuts : new Array(34),
	hostAppId : null,
	keyMap : null,
	SPACE : "SPACE",
	fontMap : null,

	appendMenuListItem : function (menuList, label, value) {
		try {
			const XULNS = "http://www.mozilla.org/keymaster/gatekeeper/there.is.only.xul";
			var popup = menuList.menupopup || menuList.appendChild(document.createElementNS(XULNS, "menupopup"));
			var item = document.createElementNS(XULNS, "menuitem");
			item.setAttribute("label", label);
			item.setAttribute("value", value);
			popup.appendChild(item);
			return item;
		}  catch (e) {
			Application.console.log(e);
			Application.console.open();
		}
	},

	load : function() {
		try {
			var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("leetkey.");
			LeetKeyPreferencesManager.hostAppId = LeetkeyPreferenceLoaderLib.getApplicationContainerName();

			if (LeetKeyPreferencesManager.hostAppId!="TB") {
				LeetKeyPreferencesManager.fontMap = LeetkeyPreferenceLoaderLib.loadPreferredLeetFont2(prefs);
				var leetFontList = document.getElementById("leetFontList");
				for(i=0;i<256;i++) {
					var key=String.fromCharCode(i);
					var value=LeetKeyPreferencesManager.fontMap[key];
					if (value!=null && value!=undefined) {
						if (key==' ') {
							LeetKeyPreferencesManager.appendMenuListItem(leetFontList, LeetKeyPreferencesManager.SPACE, "");
						} else {
							LeetKeyPreferencesManager.appendMenuListItem(leetFontList, key, "");
						}
					}
				}
				leetFontList.selectedIndex=0;
				LeetKeyPreferencesManager.drawFontLetter(leetFontList.selectedItem.label);
			} else {
				//var leetFontList = document.getElementById("leetFontList");
				//leetFontList.hidden=true;
				//var textarea = document.getElementById("textarea");
				//textarea.hidden=true;
				document.getElementById("leetFontRow").hidden=true;
				document.getElementById("LeetFontShortcutMenuItem").hidden=true;
			}


			LeetkeyPreferenceLoaderLib.loadPreferredShortcuts(prefs);
			var savedLabel = document.getElementById("savedLabel");
			if (LeetKeyPreferencesManager.hostAppId=="FF") {
				savedLabel.value="SAVED.  Please restart FireFox."
			} else if (LeetKeyPreferencesManager.hostAppId=="TB") {
				savedLabel.value="SAVED.  Please restart ThunderBird."
			}

			document.getElementById("bgc-rgb-offset-red").value = prefs.getIntPref("editor.style.bgc-rgb-offset-red");
			document.getElementById("bgc-rgb-offset-green").value = prefs.getIntPref("editor.style.bgc-rgb-offset-green");
			document.getElementById("bgc-rgb-offset-blue").value = prefs.getIntPref("editor.style.bgc-rgb-offset-blue");
			document.getElementById("fgc-rgb-offset-red").value = prefs.getIntPref("editor.style.fgc-rgb-offset-red");
			document.getElementById("fgc-rgb-offset-green").value = prefs.getIntPref("editor.style.fgc-rgb-offset-green");
			document.getElementById("fgc-rgb-offset-blue").value = prefs.getIntPref("editor.style.fgc-rgb-offset-blue");

			document.getElementById("texteditor-rows").value = prefs.getIntPref("editor.rows");
			document.getElementById("texteditor-cols").value = prefs.getIntPref("editor.cols");

			document.getElementById("type-text-loop").value = LK_toDisplayableString(prefs.getCharPref("TextLoop"));


			LeetKeyPreferencesManager.keyMap = LeetkeyPreferenceLoaderLib.loadPreferredKeyboardMap2(prefs);
			var leetList = document.getElementById("leetList");
			for(i=0;i<256;i++) {
				var key=String.fromCharCode(i);
				var value=LeetKeyPreferencesManager.keyMap[key];
				if (value!=null) {
					if (key==' ') {
						LeetKeyPreferencesManager.appendMenuListItem(leetList, LeetKeyPreferencesManager.SPACE, value);
					} else {
						value=LK_toDisplayableString2(value);
						LeetKeyPreferencesManager.appendMenuListItem(leetList, key, value);
					}
				}
			}
			leetList.selectedIndex=0;
			var textbox = document.getElementById("leetTextBox");
			textbox.value = leetList.selectedItem.value;

			document.getElementById("updateleetkey-checkbox").checked = prefs.getBoolPref("version.autoupdate");
			document.getElementById("showstatusbaricon-checkbox").checked = prefs.getBoolPref("statusbar.showicon");

			for(var i=0;i<LeetKeyPreferencesManager.totalShortCuts;i++) {
				LeetKeyPreferencesManager.shortCuts[i]=prefs.getCharPref("shortcuts." + i);
			}
			LeetKeyPreferencesManager.updateShortcutTextBox();
			window.sizeToContent();
		} catch(e) {
			konsoleDump(e.message);
			Application.console.log(e);
			Application.console.open();
		}
	},

	areLeetFontMapsDifferent : function(map1,map2) {
		for(var i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var oldValue=map1[key];
			if (oldValue!=null && oldValue!=undefined) {
				var newValue=map2[key];
				if (oldValue.length != newValue.length) {
					return true;
				}
				for(var j=0;j<oldValue.length && j<newValue.length;j++) {
					if(oldValue[j]!=newValue[j]) {
						return true;
					}
				}
			}
		}
		return false;
	},

	makeLeetFontString : function(map) {
		var height=map["height"];
		var outstr="[";
		for(var i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var ar=map[key];
			if (ar!=null && ar!=undefined) {

				if (key=="\\") {
					key="<BCKSLSH>";
				} else if (key=="\"") {
					key="<DBLQT>";
				}

				var fontLet="";
				for(var j=0;j<ar.length;j++) {
					var line = ar[j];
					if(line==undefined) {
						line="";
					}
					fontLet+=line+'\n';
				}
				var packedFontLet=LK_toStorageString3(LeetKeyPreferencesManager.packString(fontLet,height));
				outstr+="[\"" + key + "\",\"" + packedFontLet + "\"],";
			}
		}
		return outstr.slice(0,-1) + "]";
	},

	apply : function() {
		var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("leetkey.");

		if (LeetKeyPreferencesManager.hostAppId!="TB") {
			var map=LeetkeyPreferenceLoaderLib.loadPreferredLeetFont2(prefs);
			var fMap = LeetKeyPreferencesManager.fontMap;
			if (LeetKeyPreferencesManager.areLeetFontMapsDifferent(map,fMap)) {
				var leetFontString=LeetKeyPreferencesManager.makeLeetFontString(fMap);
				prefs.setCharPref("LeetFont", leetFontString);
			}
		}

		if (document.getElementById("bgc-rgb-offset-red").value != prefs.getIntPref("editor.style.bgc-rgb-offset-red"))
			prefs.setIntPref("editor.style.bgc-rgb-offset-red", document.getElementById("bgc-rgb-offset-red").value);
		if (document.getElementById("bgc-rgb-offset-green").value != prefs.getIntPref("editor.style.bgc-rgb-offset-green"))
			prefs.setIntPref("editor.style.bgc-rgb-offset-green", document.getElementById("bgc-rgb-offset-green").value);
		if (document.getElementById("bgc-rgb-offset-blue").value != prefs.getIntPref("editor.style.bgc-rgb-offset-blue"))
			prefs.setIntPref("editor.style.bgc-rgb-offset-blue", document.getElementById("bgc-rgb-offset-blue").value);

		if (document.getElementById("fgc-rgb-offset-red").value != prefs.getIntPref("editor.style.fgc-rgb-offset-red"))
			prefs.setIntPref("editor.style.fgc-rgb-offset-red", document.getElementById("fgc-rgb-offset-red").value);
		if (document.getElementById("fgc-rgb-offset-green").value != prefs.getIntPref("editor.style.fgc-rgb-offset-green"))
			prefs.setIntPref("editor.style.fgc-rgb-offset-green", document.getElementById("fgc-rgb-offset-green").value);
		if (document.getElementById("fgc-rgb-offset-blue").value != prefs.getIntPref("editor.style.fgc-rgb-offset-blue"))
			prefs.setIntPref("editor.style.fgc-rgb-offset-blue", document.getElementById("fgc-rgb-offset-blue").value);

		if (document.getElementById("texteditor-rows").value != prefs.getIntPref("editor.rows"))
			prefs.setIntPref("editor.rows", document.getElementById("texteditor-rows").value);
		if (document.getElementById("texteditor-cols").value != prefs.getIntPref("editor.cols"))
			prefs.setIntPref("editor.cols", document.getElementById("texteditor-cols").value);

		if (document.getElementById("type-text-loop").value != LK_toDisplayableString(prefs.getCharPref("TextLoop")))
			prefs.setCharPref("TextLoop", LK_toPrintableString(document.getElementById("type-text-loop").value));


		var keyMapStr = "[";
		for(i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var value=LeetKeyPreferencesManager.keyMap[key];
			if (value!=null) {
				value=LK_toStorageString2(value);
				keyMapStr += "[\"" + key + "\",\"" + value.replace(/\\/gi, '\\\\') + "\"],";
			}
		}
		keyMapStr = keyMapStr.slice(0,-1) + "]";
		if (keyMapStr != LK_toDisplayableString(prefs.getCharPref("KeyboardMap2Dim")))
			prefs.setCharPref("KeyboardMap2Dim", LK_toPrintableString(keyMapStr));


		if (document.getElementById("updateleetkey-checkbox").checked != prefs.getBoolPref("version.autoupdate"))
			prefs.setBoolPref("version.autoupdate", document.getElementById("updateleetkey-checkbox").checked);

		if (document.getElementById("showstatusbaricon-checkbox").checked != prefs.getBoolPref("statusbar.showicon"))
			prefs.setBoolPref("statusbar.showicon", document.getElementById("showstatusbaricon-checkbox").checked);

		for(var i=0;i<LeetKeyPreferencesManager.totalShortCuts;i++) {
			prefs.setCharPref("shortcuts." + i, LeetKeyPreferencesManager.shortCuts[i]);
		}

		var btnApply = document.documentElement.getButton("extra1");
		btnApply.hidden=true;
		var btnCancel = document.documentElement.getButton("cancel");
		btnCancel.hidden=true;
		var savedLabel = document.getElementById("savedLabel");
		savedLabel.hidden=false;
		setTimeout("LeetKeyPreferencesManager.showGrid();", 1000);

		return true;
	},

	showGrid : function() {

		var savedLabel = document.getElementById("savedLabel");
		savedLabel.hidden=true;
		var btnApply = document.documentElement.getButton("extra1");
		btnApply.hidden=false;
		var btnCancel = document.documentElement.getButton("cancel");
		btnCancel.hidden=false;

	},

	close : function() {
		return true;
	},

	// recordShortCutKey by alex benenson
	recordShortCutKey : function(event) {
		event.preventDefault();		
		var mods = "";
		if (event.altKey) mods += (mods == "" ? "" : "+") + "Alt";
		if (event.ctrlKey) mods += (mods == "" ? "" : "+") + "Ctrl";
		if (event.shiftKey) mods += (mods == "" ? "" : "+") + "Shift";
		if (event.metaKey) mods += (mods == "" ? "" : "+") + "Meta";
		var keyCode = event.keyCode? event.keyCode : String.fromCharCode(event.charCode).toUpperCase().charCodeAt(0);
		var code = "";
		for (var i in event) {
			if (i.search(/DOM_VK_/i) == 0) 
				if (event[i] == keyCode) {
					code = i;
					break;
				}
		}
		code = code.replace(/DOM_/i, "");
		event.target.value = mods + (mods == "" ? "" : "+") + code;
		LeetKeyPreferencesManager.shortCuts[parseInt(document.getElementById("searchtype").selectedItem.value)]=event.target.value;
	},

	recordNumber : function(event, min, max) {
		if (event.altKey || event.ctrlKey || event.shiftKey || event.metaKey) {
			event.preventDefault();
			return;
		}
		if (event.charCode==0) {
			return;
		}
		if (event.charCode>=48 && event.charCode<=57) {
			var dec = event.charCode-48;
			var value = event.target.value;
			var maxLength=(event.target).maxLength;
			if (event.target.selectionStart==0 && event.target.selectionEnd==event.target.value.length) {
				return;
			} else if (value.length>=maxLength) {
				event.preventDefault();
				return;
			}
			var newValue=value+dec;
			var numNewVal;
			try {
				numNewVal = parseInt(newValue);
				if (numNewVal==NaN) throw "";
			} catch (e) {
				event.preventDefault();
				return;
			}
			if (numNewVal<min || numNewVal>max) {
				event.preventDefault();
				return;
			}
		} else if (event.charCode!=45) {
			// if not -
			event.preventDefault();
			return;
		}
	},

	updateShortcutTextBox : function(event) {
		//var prefs = Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("leetkey.");
		var textbox = document.getElementById("menuitem-shortcut");
		textbox.value = LeetKeyPreferencesManager.shortCuts[parseInt(document.getElementById("searchtype").selectedItem.value)];
	},

	updateLeetTextBox : function(event) {
		var textbox = document.getElementById("leetTextBox");
		textbox.value = event.target.value;
	},

	updateLeetKeyValue : function(event) {
		var textbox = document.getElementById("leetTextBox");
		var leetList = document.getElementById("leetList");
		var menuItem = leetList.selectedItem;
		menuItem.setAttribute("value", textbox.value);
		if (menuItem.label==LeetKeyPreferencesManager.SPACE) {
			LeetKeyPreferencesManager.keyMap[" "]=menuItem.value;
		} else {
			LeetKeyPreferencesManager.keyMap[menuItem.label]=menuItem.value;
		}
	},

	changeStyle : function(bgR,bgG,bgB,fgR,fgG,fgB) {
		document.getElementById("bgc-rgb-offset-red").value = bgR;
		document.getElementById("bgc-rgb-offset-green").value = bgG;
		document.getElementById("bgc-rgb-offset-blue").value = bgB;
		document.getElementById("fgc-rgb-offset-red").value = fgR;
		document.getElementById("fgc-rgb-offset-green").value = fgG;
		document.getElementById("fgc-rgb-offset-blue").value = fgB;
	},

	recordFontChar : function(event) {
		//if (event.altKey || event.ctrlKey || event.shiftKey || event.metaKey) {
		//	event.preventDefault();
		//	return;
		//}
		var ch=String.fromCharCode(event.charCode);
		if (event.charCode==0) {
			return;
		}

		var fMap = LeetKeyPreferencesManager.fontMap;
		var height=fMap["height"];
		var ar=new Array(height);
		var textarea = document.getElementById("textarea");
		var str = LeetKeyPreferencesManager.forceLetterDimensions(textarea.value, height);
		textarea.value=str;
		var lines = str.split('\n');
		var j=0;
		for (; j < lines.length && j<height; j++) {
			ar[j]=lines[j];
		}
		for(var i=j;i<height;i++) {
			ar[i]="";
		}

		var leetFontList = document.getElementById("leetFontList");
		var let1=leetFontList.selectedItem.label;
		if (let1==LeetKeyPreferencesManager.SPACE) {
			let1=" ";
		}
		fMap[let1]=ar;

		//if (ch=='B') {
		//	event.preventDefault();
		//	return;
		//}
	},

	drawFontLetter : function(let1) {
		if (let1==LeetKeyPreferencesManager.SPACE) {
			let1=" ";
		}
		var fMap = LeetKeyPreferencesManager.fontMap;
		var ar=fMap[let1];
		var textarea = document.getElementById("textarea");
		var ch=let1.toUpperCase();
		var height=fMap["height"];
		var strout="";
		for(var x=0;x<height;x++) {
			var ar = fMap[ch];
			if (ar[x]==undefined) {
				strout+='\n';
			} else {
				strout+=ar[x]+'\n';
			}
		}
		textarea.value=strout;
	},

	forceLetterDimensions : function(str, height) {
		var lines = str.split('\n');
		var j=0;
		var longestLine=0;
		for (; j < lines.length && j<height; j++) {
			if(lines[j].length>longestLine) {
				longestLine=lines[j].length;
			}
		}
		j=0;
		var strout="";
		for (; j < lines.length && j<height; j++) {
			strout+=lines[j];
			if(longestLine>lines[j].length) {
				for(var k=lines[j].length;k<longestLine;k++) {
					strout+=" ";
				}
			}
			strout+='\n';
		}
		var emptyLine="";
		for(var k=0;k<longestLine;k++) {
			emptyLine+=" ";
		}
		for(var i=j;i<height;i++) {
			strout+=emptyLine+'\n';
		}
		return strout;
	},

	packString : function(str,height) {
		var lines = str.split('\n');
		var outstr="";
		var j=0;
		for (; j < lines.length && j<height; j++) {
			str=lines[j];
			var ch=null;
			var x=0;
			for(var i=0;i<str.length;i++) {
				if(ch==null) {
					ch=str.charAt(i);
					x+=1;
				} else if (ch==str.charAt(i)) {
					x++;
				} else {
					outstr+=x;
					x=1;
					outstr+=ch;
					ch=str.charAt(i);
				}
			}
			outstr+=x+ch+'\n';
		}
		for(var i=j;i<height;i++) {
			outstr+='\n';
		}
		return outstr;
	}
}