var LeetKeyStyleHandlers = {

	toggleTextAlignStyle : function() {
		var nodeType = LK_TextEditorLib.getNode();
		if (!nodeType.isNodeRichText) {
			var node = nodeType.node;
			var style = node.style.textAlign;

			var savedTextAlign = node.getAttribute("LK.node.style.text-align");
			if (savedTextAlign==null || savedTextAlign=="") {
				if (!style || style==null || style=="") {
					node.setAttribute("LK.node.style.text-align", "left");
					node.style.textAlign="right";
				} else {
					node.setAttribute("LK.node.style.text-align", style);
					if (style=="right") {
						node.style.textAlign="left";
					} else {
						node.style.textAlign="right";
					}
				}
			} else {
				node.style.textAlign=savedTextAlign;
				if (savedTextAlign=="right") {
					node.setAttribute("LK.node.style.text-align", "left");
				} else {
					node.setAttribute("LK.node.style.text-align", "right");
				}

			}
		}
	},

	toggleReverseTypingStyle : function() {
		var nodeType = LK_TextEditorLib.getNode();
		if (!nodeType.isNodeRichText) {
			var node = nodeType.node;
			var style = node.style.direction;

			var savedDirection = node.getAttribute("LK.node.style.direction");
			if (savedDirection==null) {
				if (!style || style==null || style=="") {
					node.setAttribute("LK.node.style.direction", "ltr");
					node.style.direction="rtl";
				} else {
					node.setAttribute("LK.node.style.direction", style);
					if (style=="rtl") {
						node.style.direction="ltr";
					} else {
						node.style.direction="rtl";
					}
				}
			} else {
				node.style.direction=savedDirection;
				if (savedDirection=="rtl") {
					node.setAttribute("LK.node.style.direction", "ltr");
				} else {
					node.setAttribute("LK.node.style.direction", "rtl");
				}

			}
		}
	},


	resetAllStyles : function() {
		for (i in LK_TextEditorLib.textNodeMap) {
			var textNode = LK_TextEditorLib.textNodeMap[i];
			var savedTextAlign = textNode.txtnode.getAttribute("LK.node.style.text-align");
			if (savedTextAlign!=null) {
				textNode.txtnode.style.textAlign=savedTextAlign;
				textNode.txtnode.setAttribute("LK.node.style.text-align", null);
			}

			var savedTextDirection = textNode.txtnode.getAttribute("LK.node.style.direction");
			if (savedTextDirection!=null) {
				textNode.txtnode.style.direction=savedTextDirection;
				textNode.txtnode.setAttribute("LK.node.style.direction", null);
			}
		}
	}
}