var LeetKeyTransformerHandlers = {
	initLeetKeyTransformerHandlers : function() {
		LK_B64.initBase64();
	},
	transformToLeet : function(str) {
		var strout = "";
		var ch;
		for(var i=0;i<str.length;i++) {
			ch = str.charCodeAt(i);
			if (LK_TextEditorLib.isSpacePressed(ch) || ch>127 || LK_TextEditorLib.keymapSpecialFunction[ch]==true) {
				strout += String.fromCharCode(ch);
			} else {
				strout += leetKeyInit.prefLoader.leetKeyMap[String.fromCharCode(ch)];
			}
		}
		return strout;
	},
	transformFromLeet : function(instr) {
		var outstr = instr;
		for(var i=0;i<leetKeyInit.prefLoader.leetKeyStringSortedList.length;i++) {
			var curch = leetKeyInit.prefLoader.leetKeyStringSortedList[i];
			var index = -1;
			var indexLast = index;
			while((index = outstr.indexOf(curch))!=-1) {
				if (index > 200) {
					break;
				}
				if (indexLast >= index) {
					break;
				} else {
					indexLast = index;
				}
				outstr = outstr.substring(0, index) + leetKeyInit.prefLoader.leetKeyStringMap[curch] + outstr.substring(index + curch.length);
			}
		}
		return outstr.toLowerCase();
	},
	transformToSig : function(str) {
		str=leetKeyInit.prefLoader.signatureFontMap["signature"];
		var stars="";
		for(i=0;i<94;i++) stars+="*";
		stars+='\n';
		return stars + '\n' + LeetKeyTransformerHandlers.transformToLeetFont2(str, leetKeyInit.prefLoader.signatureFontMap) + stars;
	},

	transformToLeetFont : function(str) {
		return LeetKeyTransformerHandlers.transformToLeetFont2(str, leetKeyInit.prefLoader.leetFontMap);
	},

	transformToLeetFont2 : function(str, fontMap) {
		str=str.toUpperCase();
		var h=fontMap["height"];
		var ch;
		var strout="";
		var lines = str.split('\n');
		for (var j = 0; j < lines.length; j++) {
			str=lines[j];
			if(str=="") continue;
			for(var x=0;x<h;x++) {
				var line="";
				for(var i=0;i<str.length;i++) {
					ch = String.fromCharCode(str.charCodeAt(i));
					if (ch==' ') {
						line+="  ";
					} else {
						var ar = fontMap[ch];
						if (ar!=undefined && ar!=null) {
							line+=ar[x]+"  ";
						} else {
							if (x==h-1) {
								line+=ch+"  ";
							} else {
								line+="   ";
							}
						}
					}
				}
				strout+=line+"\n";
			}
			strout+="\n";
		}
		return strout;
	},
	rot13: function(instr) {
		var outstr = "";
		for (var i=0;i<instr.length;i++)
		{
			var chcodein = instr[i].charCodeAt(0);
			var chcodeout;
			if ((chcodein>=65 && chcodein<78) || (chcodein>=97 && chcodein<110)) {
				chcodeout = chcodein + 13;
			} else if ((chcodein>77 && chcodein<=90) || (chcodein>109 && chcodein<=122)) {
				chcodeout = chcodein - 13;
			} else {
				chcodeout = chcodein;
			}
			outstr += String.fromCharCode(chcodeout);
		}
		return outstr;
	},
	urlEncode: function (instr){
		var outstr=escape(instr);
		outstr=outstr.replace(new RegExp('\\+','g'),'%2B');
		return outstr.replace(new RegExp('%20','g'),'+');
	},
	urlDecode: function (instr){
		var outstr=instr.replace(new RegExp('\\+','g'),' ');
		return unescape(outstr);
	},
	encodeBase64: function (str){return LK_B64.encodeBase64(str);},
	decodeBase64: function (str){return LK_B64.decodeBase64(str);},
	encodeHex: function (str){return LK_HEX.encodeHex(str);},
	decodeHex: function (str){return LK_HEX.decodeHex(str);},
	binEncode: function (str){return LK_BIN.binEncode(str);},
	binDecode: function (str){return LK_BIN.binDecode(str);},
	encodeMorse: function(str) {return LK_MORSE.encodeMorse(str);},
	decodeMorse: function(str) {return LK_MORSE.decodeMorse(str);},
	textLoop : function() {return leetKeyInit.prefLoader.textLoop;},
	toLower : function (str){return str.toLowerCase();},
	toUpper : function (str){return str.toUpperCase();},
	toCap : function (obj, str, checkPrevChar) {
		while((result=obj.exec(str))!=null) {
			if (checkPrevChar && result.index>0) {
				var ch=str.charAt(result.index-1);
				if (ch!=' ' && ch!='\t' && ch!='\r' && ch!='\n') {continue;}
			}
			if (str.length>result.index+1) {
				str = str.substring(0, result.index) + result[0].toUpperCase() + str.substring(result.index+1);
			} else {
				str = str.substring(0, result.index) + result[0].toUpperCase();
			}
		}
		return str;
	},
	capitalize : function (str) {
		var obj=/\b\w/g;
		str = LeetKeyTransformerHandlers.toCap(obj, str, false);
		obj=/[\x81-\uffff]/g;
		return LeetKeyTransformerHandlers.toCap(obj, str, true);
	},
	reverseText : function (str){return str.reverse();},
	// DES encrypt/decrypt functionality submitted by Christopher Strider Cook   c h r i s @ d i r t y l i t t l e m o n k e y . c o m
	encodeDES: function(instr) {
		var outstr = "";
		outstr += LeetKeyTransformerHandlers.encodeBase64(DESEncDec.des(prompt('Please enter encryption key',"8bytekey"),DESEncDec.C2E(instr),1,0));
		return outstr;
	},
	decodeDES: function(instr) {
		var outstr = "";
		outstr = DESEncDec.E2C(DESEncDec.des(prompt('Please enter decryption key',"8bytekey"),LeetKeyTransformerHandlers.decodeBase64(instr),0,0));
		return outstr;
	},

	// AES encrypt/decrypt functionality provided by Chris Veness
	encodeAES: function(instr) {
		var outstr = "";
		outstr += LeetKeyTransformerHandlers.encodeBase64(AESEncDec.AESEncryptCtr(instr, prompt('Please enter encryption key',"8bytekey"),256));
		return outstr;
	},
	decodeAES: function(instr) {
		var outstr = "";
		outstr += AESEncDec.AESDecryptCtr(LeetKeyTransformerHandlers.decodeBase64(instr), prompt('Please enter decryption key',"8bytekey"),256);
		return outstr;
	}
}
var LK_BIN = {
	base2Masks : new Array(0x0,0x1,0x2,0x4,0x8,0x10,0x20,0x40,0x80),
	binEncode: function (str){
		var result = "";
		var i=0;
		for(;i<str.length;i++) {
			result += LK_BIN.toBinString(str.charCodeAt(i)&0xff) + " ";
		}
		return result;
	},
	toBinString: function (number) {
		var result=new Array("","","","","","","","");
		var i=0;
		for(;i<9;i++) {
			if ((number & LK_BIN.base2Masks[i]) == LK_BIN.base2Masks[i]) {
				if(LK_BIN.base2Masks[i]==0) {
					//result[i]="0";
				} else {
					result[i]="1";
				}
			} else {
				result[i]="0";
			}
		}	
		return result.reverse().join("");
	},
	binDecode: function (str){
		var result = "";
		var number = 0;
		var bits=8;
		var curbits=0;
		var i=0;
		for(;i<str.length;i++) {
			if (curbits==8) {
				result = LK_BIN.decodeBinCharUpdateString(result, number);
				number=0;
				curbits=0;
			}
			if(str.charAt(i)=='0') {
				curbits++;
			} else if (str.charAt(i)=='1') {
				number = number | LK_BIN.base2Masks[bits-curbits];
				curbits++;
			} else if (str.charAt(i)==' ') {
				result = LK_BIN.decodeBinCharUpdateString(result, number);
				number=0;
				curbits=0;
			}
		}
		if (curbits>0) {
			result = LK_BIN.decodeBinCharUpdateString(result, number);
		}
		return result;
	},
	decodeBinCharUpdateString: function (str, number) {
		if (number == 0) {
			return str;
		}
		var result = "";
		var ch = String.fromCharCode(number);
		if (ch=='\b') {
			if (str.length>1) {
				result = str.substring(0, str.length-1);
			} else {
				result = "";
			}					
		} else {
			result = str + ch;
		}
		return result;
	}
}
var LK_MORSE = {
	morseCodeMap : new Array('.-','-...','-.-.','-..','.','..-.','--.','....','..','.---','-.-','.-..','--','-.','---','.--.','--.-',
		'.-.','...','-','..-','...-','.--','-..-','-.--','--..','-----','.----','..---','...--','....-','.....',
		'-....','--...','---..','----.','.-.-.-','--..--','..--..'),
	morseCodeChars : new Array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x',
		'y','z','0','1','2','3','4','5','6','7','8','9','.',',','?'),
	encodeMorse: function(instr) {
		var outstr = "";
		for (var i=0;i<instr.length;i++)
		{
			var chcodein = instr[i].charCodeAt(0);
			var chout;
			if (chcodein>=65 && chcodein<=90) {
				chout = LK_MORSE.morseCodeMap[chcodein-65];
			} else if (chcodein>=97 && chcodein<=122) {
				chout = LK_MORSE.morseCodeMap[chcodein-97];
			} else if (chcodein>=48 && chcodein<=57) {
				chout = LK_MORSE.morseCodeMap[chcodein-48+26]
			} else if (chcodein==46) {
				chout = LK_MORSE.morseCodeMap[36];
			} else if (chcodein==44) {
				chout = LK_MORSE.morseCodeMap[37];
			} else if (chcodein==63) {
				chout = LK_MORSE.morseCodeMap[38];
			} else {
				chout = String.fromCharCode(chcodein);
			}
			outstr += chout + " ";
		}
		return outstr;
	},
	decodeMorse: function(instr) {
		var outstr = "";
		var inlist = instr.split("\n");
		for(var i=0;i<inlist.length;i++) {
			outstr += LK_MORSE.decodeMorseLine(inlist[i]) + "\n";
		}
		return outstr;
	},
	decodeMorseLine: function(instr) {
		var outstr = "";
		for(var i=0;i<instr.length;i++) {
			var x = instr.indexOf("  ");
			if (x==-1) {
				outstr += LK_MORSE.decodeMorseWord(instr.split(" "));
				break;
			} else {
				var wordin = instr.substring(0, x);
				instr = instr.substring(x+2);
				outstr += LK_MORSE.decodeMorseWord(wordin.split(" ")) + " ";
			}
		}
		return outstr;
	},
	decodeMorseWord: function(inlist) {
		var outword = "";
		for (var i=0;i<inlist.length;i++)
		{
			var outchar = "";
			for(var j=0;j<LK_MORSE.morseCodeMap.length;j++) {
				if (inlist[i]==LK_MORSE.morseCodeMap[j]) {
					outchar = LK_MORSE.morseCodeChars[j];
				}
			}
			if (outchar == "" ) {
				outword += inlist[i];
			} else {
				outword += outchar;
			}
		}
		return outword;
	}
}
// The following BASE64 and HEX encoding decoding code is GPLed and here is the copyright notice:
// Written by Stephen Ostermiller Copyright (C) 2003-2005 
var LK_B64 = {
	initBase64 : function() {
		for (var i=0; i < LK_B64.base64Chars.length; i++){
			LK_B64.reverseBase64Chars[LK_B64.base64Chars[i]] = i;
		}
	},
	END_OF_INPUT : -1,
	base64Chars : new Array('A','B','C','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z','a','b','c','d','e','f',
		'g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z','0','1','2','3','4','5','6','7','8','9','+','/'),
	reverseBase64Chars : new Array(),
	base64Str : null,
	base64Count : null,
	setBase64Str: function (str){
		LK_B64.base64Str = str;
		LK_B64.base64Count = 0;
	},
	readBase64: function (){    
		if (!LK_B64.base64Str) return LK_B64.END_OF_INPUT;
		if (LK_B64.base64Count >= LK_B64.base64Str.length) return LK_B64.END_OF_INPUT;
		var c = LK_B64.base64Str.charCodeAt(LK_B64.base64Count) & 0xff;
		LK_B64.base64Count++;
		return c;
	},
	encodeBase64: function (str){
		LK_B64.setBase64Str(str);
		var result = '';
		var inBuffer = new Array(3);
		var lineCount = 0;
		var done = false;
		while (!done && (inBuffer[0] = LK_B64.readBase64()) != LK_B64.END_OF_INPUT){
			inBuffer[1] = LK_B64.readBase64();
			inBuffer[2] = LK_B64.readBase64();
			result += (LK_B64.base64Chars[ inBuffer[0] >> 2 ]);
			if (inBuffer[1] != LK_B64.END_OF_INPUT){
				result += (LK_B64.base64Chars [(( inBuffer[0] << 4 ) & 0x30) | (inBuffer[1] >> 4) ]);
				if (inBuffer[2] != LK_B64.END_OF_INPUT){
					result += (LK_B64.base64Chars [((inBuffer[1] << 2) & 0x3c) | (inBuffer[2] >> 6) ]);
					result += (LK_B64.base64Chars [inBuffer[2] & 0x3F]);
				} else {
					result += (LK_B64.base64Chars [((inBuffer[1] << 2) & 0x3c)]);
					result += ('=');
					done = true;
				}
			} else {
				result += (LK_B64.base64Chars [(( inBuffer[0] << 4 ) & 0x30)]);
				result += ('=');
				result += ('=');
				done = true;
			}
			lineCount += 4;
			if (lineCount >= 76){
				result += ('\n');
				lineCount = 0;
			}
		}
		return result;
	},
	readReverseBase64: function (){
		if (!LK_B64.base64Str) return LK_B64.END_OF_INPUT;
		while (true){      
			if (LK_B64.base64Count >= LK_B64.base64Str.length) return LK_B64.END_OF_INPUT;
			var nextCharacter = LK_B64.base64Str.charAt(LK_B64.base64Count);
			LK_B64.base64Count++;
			if (LK_B64.reverseBase64Chars[nextCharacter]){
				return LK_B64.reverseBase64Chars[nextCharacter];
			}
			if (nextCharacter == 'A') return 0;
		}
		return LK_B64.END_OF_INPUT;
	},
	ntos: function (n){
		n=n.toString(16);
		if (n.length == 1) n="0"+n;
		n="%"+n;
		return unescape(n);
	},
	decodeBase64: function (str){
		LK_B64.setBase64Str(str);
		var result = "";
		var inBuffer = new Array(4);
		var done = false;
		while (!done && (inBuffer[0] = LK_B64.readReverseBase64()) != LK_B64.END_OF_INPUT
		&& (inBuffer[1] = LK_B64.readReverseBase64()) != LK_B64.END_OF_INPUT){
			inBuffer[2] = LK_B64.readReverseBase64();
			inBuffer[3] = LK_B64.readReverseBase64();
			result += LK_B64.ntos((((inBuffer[0] << 2) & 0xff)| inBuffer[1] >> 4));
			if (inBuffer[2] != LK_B64.END_OF_INPUT){
				result += LK_B64.ntos((((inBuffer[1] << 4) & 0xff)| inBuffer[2] >> 2));
				if (inBuffer[3] != LK_B64.END_OF_INPUT){
					result += LK_B64.ntos((((inBuffer[2] << 6)  & 0xff) | inBuffer[3]));
				} else {
					done = true;
				}
			} else {
				done = true;
			}
		}
		return result;
	}
}
var LK_HEX = {
	digitArray : new Array('0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'),
	toHex: function (n){
		var result = ''
		var start = true;
		for (var i=32; i>0;){
			i-=4;
			var digit = (n>>i) & 0xf;
			if (!start || digit != 0){
				start = false;
				result += LK_HEX.digitArray[digit];
			}
		}
		return (result==''?'0':result);
	},
	pad: function (str, len, pad){
		var result = str;
		for (var i=str.length; i<len; i++){
			result = pad + result;
		}
		return result;
	},
	encodeHex: function (str){
		var result = "";
		for (var i=0; i<str.length; i++){
			result += LK_HEX.pad(LK_HEX.toHex(str.charCodeAt(i)&0xff),2,'0') + " ";
		}
		return result;
	},
	decodeHex: function (str){
		str = str.replace(new RegExp("s/[^0-9a-zA-Z]//g"));
		var result = "";
		var nextchar = "";
		for (var i=0; i<str.length; i++){
			if(str.charAt(i)==' ') {
				nextchar = "";
			} else {
				nextchar += str.charAt(i);
			}
			if (nextchar.length == 2) {
				if (nextchar=="08") {
					if (result.length>1) {
						result = result.substring(0, result.length-1);
					} else {
						result = "";
					}
				} else {
					result += LK_B64.ntos(eval('0x'+nextchar));
				}
				nextchar = "";
			}
		}
		return result;
	}
}
var DESEncDec = {
	// DES encrypt/decrypt functionality submitted by Christopher Strider Cook   c h r i s @ d i r t y l i t t l e m o n k e y . c o m
	
	//Javascript version
	//Paul Tero, July 2001
	//http://www.shopable.co.uk/des.html
	//
	//Optimised for performance with large blocks by Michael Hayworth, November 2001
	//http://www.netdealing.com
	//
	//THIS SOFTWARE IS PROVIDED "AS IS" AND
	//ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
	//IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
	//ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
	//FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
	//DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
	//OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
	//HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
	//LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
	//OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
	//SUCH DAMAGE.
	
	//des
	//this takes the key, the message, and whether to encrypt or decrypt
	des: function (key, message, encrypt, mode, iv) {
	  //declaring this locally speeds things up a bit
	  var spfunction1 = new Array (0x1010400,0,0x10000,0x1010404,0x1010004,0x10404,0x4,0x10000,0x400,0x1010400,0x1010404,0x400,0x1000404,0x1010004,0x1000000,0x4,0x404,0x1000400,0x1000400,0x10400,0x10400,0x1010000,0x1010000,0x1000404,0x10004,0x1000004,0x1000004,0x10004,0,0x404,0x10404,0x1000000,0x10000,0x1010404,0x4,0x1010000,0x1010400,0x1000000,0x1000000,0x400,0x1010004,0x10000,0x10400,0x1000004,0x400,0x4,0x1000404,0x10404,0x1010404,0x10004,0x1010000,0x1000404,0x1000004,0x404,0x10404,0x1010400,0x404,0x1000400,0x1000400,0,0x10004,0x10400,0,0x1010004);
	  var spfunction2 = new Array (-0x7fef7fe0,-0x7fff8000,0x8000,0x108020,0x100000,0x20,-0x7fefffe0,-0x7fff7fe0,-0x7fffffe0,-0x7fef7fe0,-0x7fef8000,-0x80000000,-0x7fff8000,0x100000,0x20,-0x7fefffe0,0x108000,0x100020,-0x7fff7fe0,0,-0x80000000,0x8000,0x108020,-0x7ff00000,0x100020,-0x7fffffe0,0,0x108000,0x8020,-0x7fef8000,-0x7ff00000,0x8020,0,0x108020,-0x7fefffe0,0x100000,-0x7fff7fe0,-0x7ff00000,-0x7fef8000,0x8000,-0x7ff00000,-0x7fff8000,0x20,-0x7fef7fe0,0x108020,0x20,0x8000,-0x80000000,0x8020,-0x7fef8000,0x100000,-0x7fffffe0,0x100020,-0x7fff7fe0,-0x7fffffe0,0x100020,0x108000,0,-0x7fff8000,0x8020,-0x80000000,-0x7fefffe0,-0x7fef7fe0,0x108000);
	  var spfunction3 = new Array (0x208,0x8020200,0,0x8020008,0x8000200,0,0x20208,0x8000200,0x20008,0x8000008,0x8000008,0x20000,0x8020208,0x20008,0x8020000,0x208,0x8000000,0x8,0x8020200,0x200,0x20200,0x8020000,0x8020008,0x20208,0x8000208,0x20200,0x20000,0x8000208,0x8,0x8020208,0x200,0x8000000,0x8020200,0x8000000,0x20008,0x208,0x20000,0x8020200,0x8000200,0,0x200,0x20008,0x8020208,0x8000200,0x8000008,0x200,0,0x8020008,0x8000208,0x20000,0x8000000,0x8020208,0x8,0x20208,0x20200,0x8000008,0x8020000,0x8000208,0x208,0x8020000,0x20208,0x8,0x8020008,0x20200);
	  var spfunction4 = new Array (0x802001,0x2081,0x2081,0x80,0x802080,0x800081,0x800001,0x2001,0,0x802000,0x802000,0x802081,0x81,0,0x800080,0x800001,0x1,0x2000,0x800000,0x802001,0x80,0x800000,0x2001,0x2080,0x800081,0x1,0x2080,0x800080,0x2000,0x802080,0x802081,0x81,0x800080,0x800001,0x802000,0x802081,0x81,0,0,0x802000,0x2080,0x800080,0x800081,0x1,0x802001,0x2081,0x2081,0x80,0x802081,0x81,0x1,0x2000,0x800001,0x2001,0x802080,0x800081,0x2001,0x2080,0x800000,0x802001,0x80,0x800000,0x2000,0x802080);
	  var spfunction5 = new Array (0x100,0x2080100,0x2080000,0x42000100,0x80000,0x100,0x40000000,0x2080000,0x40080100,0x80000,0x2000100,0x40080100,0x42000100,0x42080000,0x80100,0x40000000,0x2000000,0x40080000,0x40080000,0,0x40000100,0x42080100,0x42080100,0x2000100,0x42080000,0x40000100,0,0x42000000,0x2080100,0x2000000,0x42000000,0x80100,0x80000,0x42000100,0x100,0x2000000,0x40000000,0x2080000,0x42000100,0x40080100,0x2000100,0x40000000,0x42080000,0x2080100,0x40080100,0x100,0x2000000,0x42080000,0x42080100,0x80100,0x42000000,0x42080100,0x2080000,0,0x40080000,0x42000000,0x80100,0x2000100,0x40000100,0x80000,0,0x40080000,0x2080100,0x40000100);
	  var spfunction6 = new Array (0x20000010,0x20400000,0x4000,0x20404010,0x20400000,0x10,0x20404010,0x400000,0x20004000,0x404010,0x400000,0x20000010,0x400010,0x20004000,0x20000000,0x4010,0,0x400010,0x20004010,0x4000,0x404000,0x20004010,0x10,0x20400010,0x20400010,0,0x404010,0x20404000,0x4010,0x404000,0x20404000,0x20000000,0x20004000,0x10,0x20400010,0x404000,0x20404010,0x400000,0x4010,0x20000010,0x400000,0x20004000,0x20000000,0x4010,0x20000010,0x20404010,0x404000,0x20400000,0x404010,0x20404000,0,0x20400010,0x10,0x4000,0x20400000,0x404010,0x4000,0x400010,0x20004010,0,0x20404000,0x20000000,0x400010,0x20004010);
	  var spfunction7 = new Array (0x200000,0x4200002,0x4000802,0,0x800,0x4000802,0x200802,0x4200800,0x4200802,0x200000,0,0x4000002,0x2,0x4000000,0x4200002,0x802,0x4000800,0x200802,0x200002,0x4000800,0x4000002,0x4200000,0x4200800,0x200002,0x4200000,0x800,0x802,0x4200802,0x200800,0x2,0x4000000,0x200800,0x4000000,0x200800,0x200000,0x4000802,0x4000802,0x4200002,0x4200002,0x2,0x200002,0x4000000,0x4000800,0x200000,0x4200800,0x802,0x200802,0x4200800,0x802,0x4000002,0x4200802,0x4200000,0x200800,0,0x2,0x4200802,0,0x200802,0x4200000,0x800,0x4000002,0x4000800,0x800,0x200002);
	  var spfunction8 = new Array (0x10001040,0x1000,0x40000,0x10041040,0x10000000,0x10001040,0x40,0x10000000,0x40040,0x10040000,0x10041040,0x41000,0x10041000,0x41040,0x1000,0x40,0x10040000,0x10000040,0x10001000,0x1040,0x41000,0x40040,0x10040040,0x10041000,0x1040,0,0,0x10040040,0x10000040,0x10001000,0x41040,0x40000,0x41040,0x40000,0x10041000,0x1000,0x40,0x10040040,0x1000,0x41040,0x10001000,0x40,0x10000040,0x10040000,0x10040040,0x10000000,0x40000,0x10001040,0,0x10041040,0x40040,0x10000040,0x10040000,0x10001000,0x10001040,0,0x10041040,0x41000,0x41000,0x1040,0x1040,0x40040,0x10000000,0x10041000);

	  //create the 16 or 48 subkeys we will need
	  var keys = DESEncDec.des_createKeys (key);
	  var m=0, i, j, temp, temp2, right1, right2, left, right, looping;
	  var cbcleft, cbcleft2, cbcright, cbcright2
	  var endloop, loopinc;
	  var len = message.length;
	  var chunk = 0;
	  //set up the loops for single and triple des
	  var iterations = keys.length == 32 ? 3 : 9; //single or triple des
	  if (iterations == 3) {looping = encrypt ? new Array (0, 32, 2) : new Array (30, -2, -2);}
	  else {looping = encrypt ? new Array (0, 32, 2, 62, 30, -2, 64, 96, 2) : new Array (94, 62, -2, 32, 64, 2, 30, -2, -2);}
	
	  message += "\0\0\0\0\0\0\0\0"; //pad the message out with null bytes
	  //store the result here
	  result = "";
	  tempresult = "";
	
	  if (mode == 1) { //CBC mode
	    cbcleft = (iv.charCodeAt(m++) << 24) | (iv.charCodeAt(m++) << 16) | (iv.charCodeAt(m++) << 8) | iv.charCodeAt(m++);
	    cbcright = (iv.charCodeAt(m++) << 24) | (iv.charCodeAt(m++) << 16) | (iv.charCodeAt(m++) << 8) | iv.charCodeAt(m++);
	    m=0;
	  }
	
	  //loop through each 64 bit chunk of the message
	  while (m < len) {
	    left = (message.charCodeAt(m++) << 24) | (message.charCodeAt(m++) << 16) | (message.charCodeAt(m++) << 8) | message.charCodeAt(m++);
	    right = (message.charCodeAt(m++) << 24) | (message.charCodeAt(m++) << 16) | (message.charCodeAt(m++) << 8) | message.charCodeAt(m++);
	
	    //for Cipher Block Chaining mode, xor the message with the previous result
	    if (mode == 1) {if (encrypt) {left ^= cbcleft; right ^= cbcright;} else {cbcleft2 = cbcleft; cbcright2 = cbcright; cbcleft = left; cbcright = right;}}
	
	    //first each 64 but chunk of the message must be permuted according to IP
	    temp = ((left >>> 4) ^ right) & 0x0f0f0f0f; right ^= temp; left ^= (temp << 4);
	    temp = ((left >>> 16) ^ right) & 0x0000ffff; right ^= temp; left ^= (temp << 16);
	    temp = ((right >>> 2) ^ left) & 0x33333333; left ^= temp; right ^= (temp << 2);
	    temp = ((right >>> 8) ^ left) & 0x00ff00ff; left ^= temp; right ^= (temp << 8);
	    temp = ((left >>> 1) ^ right) & 0x55555555; right ^= temp; left ^= (temp << 1);
	
	    left = ((left << 1) | (left >>> 31));
	    right = ((right << 1) | (right >>> 31));
	
	    //do this either 1 or 3 times for each chunk of the message
	    for (j=0; j<iterations; j+=3) {
	      endloop = looping[j+1];
	      loopinc = looping[j+2];
	      //now go through and perform the encryption or decryption
	      for (i=looping[j]; i!=endloop; i+=loopinc) { //for efficiency
	        right1 = right ^ keys[i];
	        right2 = ((right >>> 4) | (right << 28)) ^ keys[i+1];
	        //the result is attained by passing these bytes through the S selection functions
	        temp = left;
	        left = right;
	        right = temp ^ (spfunction2[(right1 >>> 24) & 0x3f] | spfunction4[(right1 >>> 16) & 0x3f]
	              | spfunction6[(right1 >>>  8) & 0x3f] | spfunction8[right1 & 0x3f]
	              | spfunction1[(right2 >>> 24) & 0x3f] | spfunction3[(right2 >>> 16) & 0x3f]
	              | spfunction5[(right2 >>>  8) & 0x3f] | spfunction7[right2 & 0x3f]);
	      }
	      temp = left; left = right; right = temp; //unreverse left and right
	    } //for either 1 or 3 iterations
	
	    //move then each one bit to the right
	    left = ((left >>> 1) | (left << 31));
	    right = ((right >>> 1) | (right << 31));
	
	    //now perform IP-1, which is IP in the opposite direction
	    temp = ((left >>> 1) ^ right) & 0x55555555; right ^= temp; left ^= (temp << 1);
	    temp = ((right >>> 8) ^ left) & 0x00ff00ff; left ^= temp; right ^= (temp << 8);
	    temp = ((right >>> 2) ^ left) & 0x33333333; left ^= temp; right ^= (temp << 2);
	    temp = ((left >>> 16) ^ right) & 0x0000ffff; right ^= temp; left ^= (temp << 16);
	    temp = ((left >>> 4) ^ right) & 0x0f0f0f0f; right ^= temp; left ^= (temp << 4);
	
	    //for Cipher Block Chaining mode, xor the message with the previous result
	    if (mode == 1) {if (encrypt) {cbcleft = left; cbcright = right;} else {left ^= cbcleft2; right ^= cbcright2;}}
	    tempresult += String.fromCharCode ((left>>>24), ((left>>>16) & 0xff), ((left>>>8) & 0xff), (left & 0xff), (right>>>24), ((right>>>16) & 0xff), ((right>>>8) & 0xff), (right & 0xff));
	
	    chunk += 8;
	    if (chunk == 512) {result += tempresult; tempresult = ""; chunk = 0;}
	  } //for every 8 characters, or 64 bits in the message
	
	  //return the result as an array
	  return result + tempresult;
	}, //end of des
	
	
	
	//des_createKeys
	//this takes as input a 64 bit key (even though only 56 bits are used)
	//as an array of 2 integers, and returns 16 48 bit keys
	des_createKeys: function (key) {
	  //declaring this locally speeds things up a bit
	  pc2bytes0  = new Array (0,0x4,0x20000000,0x20000004,0x10000,0x10004,0x20010000,0x20010004,0x200,0x204,0x20000200,0x20000204,0x10200,0x10204,0x20010200,0x20010204);
	  pc2bytes1  = new Array (0,0x1,0x100000,0x100001,0x4000000,0x4000001,0x4100000,0x4100001,0x100,0x101,0x100100,0x100101,0x4000100,0x4000101,0x4100100,0x4100101);
	  pc2bytes2  = new Array (0,0x8,0x800,0x808,0x1000000,0x1000008,0x1000800,0x1000808,0,0x8,0x800,0x808,0x1000000,0x1000008,0x1000800,0x1000808);
	  pc2bytes3  = new Array (0,0x200000,0x8000000,0x8200000,0x2000,0x202000,0x8002000,0x8202000,0x20000,0x220000,0x8020000,0x8220000,0x22000,0x222000,0x8022000,0x8222000);
	  pc2bytes4  = new Array (0,0x40000,0x10,0x40010,0,0x40000,0x10,0x40010,0x1000,0x41000,0x1010,0x41010,0x1000,0x41000,0x1010,0x41010);
	  pc2bytes5  = new Array (0,0x400,0x20,0x420,0,0x400,0x20,0x420,0x2000000,0x2000400,0x2000020,0x2000420,0x2000000,0x2000400,0x2000020,0x2000420);
	  pc2bytes6  = new Array (0,0x10000000,0x80000,0x10080000,0x2,0x10000002,0x80002,0x10080002,0,0x10000000,0x80000,0x10080000,0x2,0x10000002,0x80002,0x10080002);
	  pc2bytes7  = new Array (0,0x10000,0x800,0x10800,0x20000000,0x20010000,0x20000800,0x20010800,0x20000,0x30000,0x20800,0x30800,0x20020000,0x20030000,0x20020800,0x20030800);
	  pc2bytes8  = new Array (0,0x40000,0,0x40000,0x2,0x40002,0x2,0x40002,0x2000000,0x2040000,0x2000000,0x2040000,0x2000002,0x2040002,0x2000002,0x2040002);
	  pc2bytes9  = new Array (0,0x10000000,0x8,0x10000008,0,0x10000000,0x8,0x10000008,0x400,0x10000400,0x408,0x10000408,0x400,0x10000400,0x408,0x10000408);
	  pc2bytes10 = new Array (0,0x20,0,0x20,0x100000,0x100020,0x100000,0x100020,0x2000,0x2020,0x2000,0x2020,0x102000,0x102020,0x102000,0x102020);
	  pc2bytes11 = new Array (0,0x1000000,0x200,0x1000200,0x200000,0x1200000,0x200200,0x1200200,0x4000000,0x5000000,0x4000200,0x5000200,0x4200000,0x5200000,0x4200200,0x5200200);
	  pc2bytes12 = new Array (0,0x1000,0x8000000,0x8001000,0x80000,0x81000,0x8080000,0x8081000,0x10,0x1010,0x8000010,0x8001010,0x80010,0x81010,0x8080010,0x8081010);
	  pc2bytes13 = new Array (0,0x4,0x100,0x104,0,0x4,0x100,0x104,0x1,0x5,0x101,0x105,0x1,0x5,0x101,0x105);
	
	  //how many iterations (1 for des, 3 for triple des)
	  var iterations = key.length >= 24 ? 3 : 1;
	  //stores the return keys
	  var keys = new Array (32 * iterations);
	  //now define the left shifts which need to be done
	  var shifts = new Array (0, 0, 1, 1, 1, 1, 1, 1, 0, 1, 1, 1, 1, 1, 1, 0);
	  //other variables
	  var lefttemp, righttemp, m=0, n=0, temp;
	
	  for (var j=0; j<iterations; j++) { //either 1 or 3 iterations
	    left = (key.charCodeAt(m++) << 24) | (key.charCodeAt(m++) << 16) | (key.charCodeAt(m++) << 8) | key.charCodeAt(m++);
	    right = (key.charCodeAt(m++) << 24) | (key.charCodeAt(m++) << 16) | (key.charCodeAt(m++) << 8) | key.charCodeAt(m++);
	
	    temp = ((left >>> 4) ^ right) & 0x0f0f0f0f; right ^= temp; left ^= (temp << 4);
	    temp = ((right >>> -16) ^ left) & 0x0000ffff; left ^= temp; right ^= (temp << -16);
	    temp = ((left >>> 2) ^ right) & 0x33333333; right ^= temp; left ^= (temp << 2);
	    temp = ((right >>> -16) ^ left) & 0x0000ffff; left ^= temp; right ^= (temp << -16);
	    temp = ((left >>> 1) ^ right) & 0x55555555; right ^= temp; left ^= (temp << 1);
	    temp = ((right >>> 8) ^ left) & 0x00ff00ff; left ^= temp; right ^= (temp << 8);
	    temp = ((left >>> 1) ^ right) & 0x55555555; right ^= temp; left ^= (temp << 1);
	
	    //the right side needs to be shifted and to get the last four bits of the left side
	    temp = (left << 8) | ((right >>> 20) & 0x000000f0);
	    //left needs to be put upside down
	    left = (right << 24) | ((right << 8) & 0xff0000) | ((right >>> 8) & 0xff00) | ((right >>> 24) & 0xf0);
	    right = temp;
	
	    //now go through and perform these shifts on the left and right keys
	    for (i=0; i < shifts.length; i++) {
	      //shift the keys either one or two bits to the left
	      if (shifts[i]) {left = (left << 2) | (left >>> 26); right = (right << 2) | (right >>> 26);}
	      else {left = (left << 1) | (left >>> 27); right = (right << 1) | (right >>> 27);}
	      left &= -0xf; right &= -0xf;
	
	      //now apply PC-2, in such a way that E is easier when encrypting or decrypting
	      //this conversion will look like PC-2 except only the last 6 bits of each byte are used
	      //rather than 48 consecutive bits and the order of lines will be according to
	      //how the S selection functions will be applied: S2, S4, S6, S8, S1, S3, S5, S7
	      lefttemp = pc2bytes0[left >>> 28] | pc2bytes1[(left >>> 24) & 0xf]
	              | pc2bytes2[(left >>> 20) & 0xf] | pc2bytes3[(left >>> 16) & 0xf]
	              | pc2bytes4[(left >>> 12) & 0xf] | pc2bytes5[(left >>> 8) & 0xf]
	              | pc2bytes6[(left >>> 4) & 0xf];
	      righttemp = pc2bytes7[right >>> 28] | pc2bytes8[(right >>> 24) & 0xf]
	                | pc2bytes9[(right >>> 20) & 0xf] | pc2bytes10[(right >>> 16) & 0xf]
	                | pc2bytes11[(right >>> 12) & 0xf] | pc2bytes12[(right >>> 8) & 0xf]
	                | pc2bytes13[(right >>> 4) & 0xf];
	      temp = ((righttemp >>> 16) ^ lefttemp) & 0x0000ffff;
	      keys[n++] = lefttemp ^ temp; keys[n++] = righttemp ^ (temp << 16);
	    }
	  } //for each iterations
	  //return the keys we've created
	  return keys;
	}, //end of des_createKeys
	
	C2E: function (str) {
	    str = str.replace(/&/g, '&#38;');
	    str = str.replace(/'/g, '&#39;');
	    str = str.replace(/"/g, '&#34;');
	    str = str.replace(/\\/g, '&#92;');
	    var acc = '';
	    for (var i = 0; i < str.length; i++) {
	        if (str.charCodeAt(i) > 31 && str.charCodeAt(i) < 127) acc += str.charAt(i)
	        else acc += '&#' + str.charCodeAt(i) + ';';
	    }
	    return acc;
	},
	
	E2C: function (str) {
	    str = str.replace(/(&#[0-9]+;)/g, '\n$1\n');
	    str = str.replace(/\n\n/g, '\n');
	    spl = str.split('\n');
	    for (var i = 0; i < spl.length; i++) {
	        if (spl[i].charAt(0) == '&') {
	            spl[i] = spl[i].replace(/&#([0-9]+);/g, '$1');
	            spl[i] = String.fromCharCode(spl[i]);
	        }
	    }
	    str = spl.join('');
	    return str;
	}
}

// Original code by Chris Veness http://www.movable-type.co.uk/scripts/aes.html modified for LeetKey purpose.
var AESEncDec = {

	// Sbox is pre-computed multiplicative inverse in GF(2^8) used in SubBytes and KeyExpansion [5.1.1]
	Sbox : [0x63,0x7c,0x77,0x7b,0xf2,0x6b,0x6f,0xc5,0x30,0x01,0x67,0x2b,0xfe,0xd7,0xab,0x76,
		0xca,0x82,0xc9,0x7d,0xfa,0x59,0x47,0xf0,0xad,0xd4,0xa2,0xaf,0x9c,0xa4,0x72,0xc0,
		0xb7,0xfd,0x93,0x26,0x36,0x3f,0xf7,0xcc,0x34,0xa5,0xe5,0xf1,0x71,0xd8,0x31,0x15,
		0x04,0xc7,0x23,0xc3,0x18,0x96,0x05,0x9a,0x07,0x12,0x80,0xe2,0xeb,0x27,0xb2,0x75,
		0x09,0x83,0x2c,0x1a,0x1b,0x6e,0x5a,0xa0,0x52,0x3b,0xd6,0xb3,0x29,0xe3,0x2f,0x84,
		0x53,0xd1,0x00,0xed,0x20,0xfc,0xb1,0x5b,0x6a,0xcb,0xbe,0x39,0x4a,0x4c,0x58,0xcf,
		0xd0,0xef,0xaa,0xfb,0x43,0x4d,0x33,0x85,0x45,0xf9,0x02,0x7f,0x50,0x3c,0x9f,0xa8,
		0x51,0xa3,0x40,0x8f,0x92,0x9d,0x38,0xf5,0xbc,0xb6,0xda,0x21,0x10,0xff,0xf3,0xd2,
		0xcd,0x0c,0x13,0xec,0x5f,0x97,0x44,0x17,0xc4,0xa7,0x7e,0x3d,0x64,0x5d,0x19,0x73,
		0x60,0x81,0x4f,0xdc,0x22,0x2a,0x90,0x88,0x46,0xee,0xb8,0x14,0xde,0x5e,0x0b,0xdb,
		0xe0,0x32,0x3a,0x0a,0x49,0x06,0x24,0x5c,0xc2,0xd3,0xac,0x62,0x91,0x95,0xe4,0x79,
		0xe7,0xc8,0x37,0x6d,0x8d,0xd5,0x4e,0xa9,0x6c,0x56,0xf4,0xea,0x65,0x7a,0xae,0x08,
		0xba,0x78,0x25,0x2e,0x1c,0xa6,0xb4,0xc6,0xe8,0xdd,0x74,0x1f,0x4b,0xbd,0x8b,0x8a,
		0x70,0x3e,0xb5,0x66,0x48,0x03,0xf6,0x0e,0x61,0x35,0x57,0xb9,0x86,0xc1,0x1d,0x9e,
		0xe1,0xf8,0x98,0x11,0x69,0xd9,0x8e,0x94,0x9b,0x1e,0x87,0xe9,0xce,0x55,0x28,0xdf,
		0x8c,0xa1,0x89,0x0d,0xbf,0xe6,0x42,0x68,0x41,0x99,0x2d,0x0f,0xb0,0x54,0xbb,0x16],

	// Rcon is Round Constant used for the Key Expansion [1st col is 2^(r-1) in GF(2^8)]  [5.2]
	Rcon : [[0x00, 0x00, 0x00, 0x00],
		[0x01, 0x00, 0x00, 0x00],
		[0x02, 0x00, 0x00, 0x00],
		[0x04, 0x00, 0x00, 0x00],
		[0x08, 0x00, 0x00, 0x00],
		[0x10, 0x00, 0x00, 0x00],
		[0x20, 0x00, 0x00, 0x00],
		[0x40, 0x00, 0x00, 0x00],
		[0x80, 0x00, 0x00, 0x00],
		[0x1b, 0x00, 0x00, 0x00],
		[0x36, 0x00, 0x00, 0x00]],



	/*
	 * AES Cipher function: use 'key' to encrypt 'input' with Rijndael algorithm
	 *
	 *   takes   byte-array 'input' (16 bytes)
	 *           byte-array 'key' (16/24/32 bytes)
	 *           2D byte-array key schedule 'w' (Nr+1 x Nb bytes)
	 *   returns byte-array encrypted value (16 bytes)
	 */
	Cipher: function(input, key, w) {    // main Cipher function [5.1]
		var Nk = key.length/4  // key length (in words)
		var Nr = Nk + 6;       // no of rounds
		var Nb = 4;            // block size (in words): no of columns in state (fixed at 4 for AES)

		var state = [[],[],[],[]];  // initialise 4xNb byte-array 'state' with input
		for (var i=0; i<4*Nb; i++) state[i%4][Math.floor(i/4)] = input[i];

		state = AESEncDec.AddRoundKey(state, w, 0, Nb);

		for (var round=1; round<Nr; round++) {
			state = AESEncDec.SubBytes(state, Nb);
			state = AESEncDec.ShiftRows(state, Nb);
			state = AESEncDec.MixColumns(state, Nb);
			state = AESEncDec.AddRoundKey(state, w, round, Nb);
		}

		state = AESEncDec.SubBytes(state, Nb);
		state = AESEncDec.ShiftRows(state, Nb);
		state = AESEncDec.AddRoundKey(state, w, Nr, Nb);

		var output = new Array(4*Nb);  // convert to 1-d array before returning
		for (var i=0; i<4*Nb; i++) output[i] = state[i%4][Math.floor(i/4)];
		return output;
	},

	SubBytes: function(s, Nb) {    // apply SBox to state S [5.1.1]
		for (var r=0; r<4; r++) {
			for (var c=0; c<Nb; c++) s[r][c] = AESEncDec.Sbox[s[r][c]];
		}
		return s;
	},

	ShiftRows: function(s, Nb) {    // shift row r of state S left by r bytes [5.1.2]
		var t = new Array(4);
		for (var r=1; r<4; r++) {
			for (var c=0; c<4; c++) t[c] = s[r][(c+r)%Nb];  // shift into temp copy
			for (var c=0; c<4; c++) s[r][c] = t[c];         // and copy back
		}          // note that this will work for Nb=4,5,6, but not 7,8 (always 4 for AES):
		return s;  // see fp.gladman.plus.com/cryptography_technology/rijndael/aes.spec.311.pdf 
	},

	MixColumns: function(s, Nb) {   // combine bytes of each col of state S [5.1.3]
		for (var c=0; c<4; c++) {
			var a = new Array(4);  // 'a' is a copy of the current column from 's'
			var b = new Array(4);  // 'b' is a{02} in GF(2^8)
			for (var i=0; i<4; i++) {
				a[i] = s[i][c];
				b[i] = s[i][c]&0x80 ? s[i][c]<<1 ^ 0x011b : s[i][c]<<1;
			}
			// a[n] ^ b[n] is a{03} in GF(2^8)
			s[0][c] = b[0] ^ a[1] ^ b[1] ^ a[2] ^ a[3]; // 2*a0 + 3*a1 + a2 + a3
			s[1][c] = a[0] ^ b[1] ^ a[2] ^ b[2] ^ a[3]; // a0 * 2*a1 + 3*a2 + a3
			s[2][c] = a[0] ^ a[1] ^ b[2] ^ a[3] ^ b[3]; // a0 + a1 + 2*a2 + 3*a3
			s[3][c] = a[0] ^ b[0] ^ a[1] ^ a[2] ^ b[3]; // 3*a0 + a1 + a2 + 2*a3
		}
		return s;
	},

	AddRoundKey: function(state, w, rnd, Nb) {  // xor Round Key into state S [5.1.4]
		for (var r=0; r<4; r++) {
			for (var c=0; c<Nb; c++) state[r][c] ^= w[rnd*4+c][r];
		}
		return state;
	},

	KeyExpansion: function(key) {  // generate Key Schedule (byte-array Nr+1 x Nb) from Key [5.2]
		var Nk = key.length/4; // key length (in words)
		var Nr = Nk + 6;       // no of rounds
		var Nb = 4;            // block size: no of columns in state (fixed at 4 for AES)
		var w = new Array(Nb*(Nr+1));
		var temp = new Array(4);
		for (var i=0; i<Nk; i++) {
			var r = [key[4*i], key[4*i+1], key[4*i+2], key[4*i+3]];
			w[i] = r;
		}
		for (var i=Nk; i<(Nb*(Nr+1)); i++) {
			w[i] = new Array(4);
			for (var t=0; t<4; t++) temp[t] = w[i-1][t];
			if (i % Nk == 0) {
				temp = AESEncDec.SubWord(AESEncDec.RotWord(temp));
				for (var t=0; t<4; t++) temp[t] ^= AESEncDec.Rcon[i/Nk][t];
			} else if (Nk > 6 && i%Nk == 4) {
				temp = AESEncDec.SubWord(temp);
			}
			for (var t=0; t<4; t++) w[i][t] = w[i-Nk][t] ^ temp[t];
		}
		return w;
	},

	SubWord: function(w) {    // apply SBox to 4-byte word w
		for (var i=0; i<4; i++) w[i] = AESEncDec.Sbox[w[i]];
		return w;
	},
	
	RotWord: function(w) {    // rotate 4-byte word w left by one byte
		w[4] = w[0];
		for (var i=0; i<4; i++) w[i] = w[i+1];
		return w;
	},

	/* 
	 * Use AES to encrypt 'plaintext' with 'password' using 'nBits' key, in 'Counter' mode of operation
	 *                           - see http://csrc.nist.gov/publications/nistpubs/800-38a/sp800-38a.pdf
	 *   for each block
	 *   - outputblock = cipher(counter, key)
	 *   - cipherblock = plaintext xor outputblock
	 */
	AESEncryptCtr: function(plaintext, password, nBits) {
		if (!(nBits==128 || nBits==192 || nBits==256)) return '';  // standard allows 128/192/256 bit keys
		
		plaintext = AESEncDec.encodeUTF8(plaintext);  // so that text is single-byte characters only
		
		// for this example script, generate the key by applying Cipher to 1st 16/24/32 chars of password; 
		// for real-world applications, a more secure approach would be to hash the password e.g. with SHA-1
		var nBytes = nBits/8;  // no bytes in key
		var pwBytes = new Array(nBytes);
		for (var i=0; i<nBytes; i++) pwBytes[i] = AESEncDec.encodeUTF8(password).charCodeAt(i);
		var pwKeySchedule = AESEncDec.KeyExpansion(pwBytes);
		var key = AESEncDec.Cipher(pwBytes, pwBytes, pwKeySchedule);
		
		// initialise counter block (NIST SP800-38A B.2): millisecond time-stamp for nonce in 1st 8 bytes,
		// block counter in 2nd 8 bytes
		var blockSize = 16;  // block size fixed at 16 bytes / 128 bits (Nb=4) for AES
		var counterBlock = new Array(blockSize);  // block size fixed at 16 bytes / 128 bits (Nb=4) for AES
		var nonce = (new Date()).getTime();  // milliseconds since 1-Jan-1970
		
		// encode nonce in two stages to cater for JavaScript 32-bit limit on bitwise ops
		for (var i=0; i<4; i++) counterBlock[i] = (nonce >>> i*8) & 0xff;
		for (var i=0; i<4; i++) counterBlock[i+4] = (nonce/0x100000000 >>> i*8) & 0xff; 
		
		// generate key schedule - an expansion of the key into distinct Key Rounds for each round
		var keySchedule = AESEncDec.KeyExpansion(key);
		
		var blockCount = Math.ceil(plaintext.length/blockSize);
		var ciphertext = new Array(blockCount);  // ciphertext as array of strings
		
		for (var b=0; b<blockCount; b++) {
			// set counter (block #) in last 8 bytes of counter block (leaving nonce in 1st 8 bytes)
			// again done in two stages for 32-bit ops
			for (var c=0; c<4; c++) counterBlock[15-c] = (b >>> c*8) & 0xff;
			for (var c=0; c<4; c++) counterBlock[15-c-4] = (b/0x100000000 >>> c*8)

			var cipherCntr = AESEncDec.Cipher(counterBlock, key, keySchedule);  // -- encrypt counter block --

			// calculate length of final block:
			var blockLength = b<blockCount-1 ? blockSize : (plaintext.length-1)%blockSize+1;

			var ct = '';
			for (var i=0; i<blockLength; i++) {  // -- xor plaintext with ciphered counter byte-by-byte --
				var plaintextByte = plaintext.charCodeAt(b*blockSize+i);
				var cipherByte = plaintextByte ^ cipherCntr[i];
				ct += String.fromCharCode(cipherByte);
			}
			// ct is now ciphertext for this block
			ciphertext[b] = AESEncDec.escCtrlChars(ct);  // escape troublesome characters in ciphertext
		}

		// convert the nonce to a string to go on the front of the ciphertext
		var ctrTxt = '';
		for (var i=0; i<8; i++) ctrTxt += String.fromCharCode(counterBlock[i]);
		ctrTxt = AESEncDec.escCtrlChars(ctrTxt);
		
		// use '-' to separate blocks, use Array.join to concatenate arrays of strings for efficiency
		return ctrTxt + '-' + ciphertext.join('-');
	},


	/* 
	 * Use AES to decrypt 'ciphertext' with 'password' using 'nBits' key, in Counter mode of operation
	 *
	 *   for each block
	 *   - outputblock = cipher(counter, key)
	 *   - cipherblock = plaintext xor outputblock
	 */
	AESDecryptCtr: function(ciphertext, password, nBits) {
		if (!(nBits==128 || nBits==192 || nBits==256)) return '';  // standard allows 128/192/256 bit keys

		var nBytes = nBits/8;  // no bytes in key
		var pwBytes = new Array(nBytes);
		for (var i=0; i<nBytes; i++) pwBytes[i] = AESEncDec.encodeUTF8(password).charCodeAt(i);
		var pwKeySchedule = AESEncDec.KeyExpansion(pwBytes);
		var key = AESEncDec.Cipher(pwBytes, pwBytes, pwKeySchedule);

		var keySchedule = AESEncDec.KeyExpansion(key);

		ciphertext = ciphertext.split('-');  // split ciphertext into array of block-length strings 

		// recover nonce from 1st element of ciphertext
		var blockSize = 16;  // block size fixed at 16 bytes / 128 bits (Nb=4) for AES
		var counterBlock = new Array(blockSize);
		var ctrTxt = AESEncDec.unescCtrlChars(ciphertext[0]);
		for (var i=0; i<8; i++) counterBlock[i] = ctrTxt.charCodeAt(i);

		var plaintext = new Array(ciphertext.length-1);

		for (var b=1; b<ciphertext.length; b++) {
			// set counter (block #) in last 8 bytes of counter block (leaving nonce in 1st 8 bytes)
			for (var c=0; c<4; c++) counterBlock[15-c] = ((b-1) >>> c*8) & 0xff;
			for (var c=0; c<4; c++) counterBlock[15-c-4] = ((b/0x100000000-1) >>> c*8) & 0xff;

			var cipherCntr = AESEncDec.Cipher(counterBlock, key, keySchedule);  // encrypt counter block

			ciphertext[b] = AESEncDec.unescCtrlChars(ciphertext[b]);

			var pt = '';
			for (var i=0; i<ciphertext[b].length; i++) {  // -- xor plaintext with ciphered counter byte-by-byte --
				var ciphertextByte = ciphertext[b].charCodeAt(i);
				var plaintextByte = ciphertextByte ^ cipherCntr[i];
				pt += String.fromCharCode(plaintextByte);
			}
			// pt is now plaintext for this block
			plaintext[b-1] = pt;  // b-1 'cos no initial nonce block in plaintext
		}
		return AESEncDec.decodeUTF8(plaintext.join(''));
	},

	encodeUTF8: function(str) {  // encode multi-byte string into utf-8 multiple single-byte characters 
		str = str.replace(
			/[\u0080-\u07ff]/g,  // U+0080 - U+07FF = 2-byte chars
			function(c) { 
				var cc = c.charCodeAt(0);
				return String.fromCharCode(0xc0 | cc>>6, 0x80 | cc&0x3f); }
			);
		str = str.replace(
			/[\u0800-\uffff]/g,  // U+0800 - U+FFFF = 3-byte chars
			function(c) { 
				var cc = c.charCodeAt(0); 
				return String.fromCharCode(0xe0 | cc>>12, 0x80 | cc>>6&0x3F, 0x80 | cc&0x3f); }
			);
		return str;
	},

	decodeUTF8: function(str) {  // decode utf-8 encoded string back into multi-byte characters
		str = str.replace(
			/[\u00c0-\u00df][\u0080-\u00bf]/g,                 // 2-byte chars
			function(c) { 
				var cc = (c.charCodeAt(0)&0x1f)<<6 | c.charCodeAt(1)&0x3f;
				return String.fromCharCode(cc); }
			);
		str = str.replace(
			/[\u00e0-\u00ef][\u0080-\u00bf][\u0080-\u00bf]/g,  // 3-byte chars
			function(c) { 
				var cc = (c.charCodeAt(0)&0x0f)<<12 | (c.charCodeAt(1)&0x3f<<6) | c.charCodeAt(2)&0x3f; 
				return String.fromCharCode(cc); }
			);
		return str;
	},

	escCtrlChars: function(str) {  // escape control chars which might cause problems handling ciphertext
		return str.replace(/[\0\t\n\v\f\r\xa0!-]/g, function(c) { return '!' + c.charCodeAt(0) + '!'; });
	},  // \xa0 to cater for bug in Firefox; include '-' to leave it free for use as a block marker

	unescCtrlChars: function(str) {  // unescape potentially problematic control characters
		return str.replace(/!\d\d?\d?!/g, function(c) { return String.fromCharCode(c.slice(1,-1)); });
	}

}