// Leet Key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

var LeetkeyPreferenceLoaderLib = {

	versionUpdateCounterRollover : 300,
	hostAppId : null,
	leetKeyVersion : null,
	showIcon : true,

	LeetkeyPreferenceLoaderLib : function() {
		this.hostAppId=null;
		this.leetKeyVersion=null;
		this.tryUpdating=false;
		this.updateVersionCounter=0;
		this.shortCutString=null;
		this.leetKeyStrings = null;
		this.leetKeyMap=new Array();
		this.leetKeyStringMap = new Array(52);
		this.leetKeyStringSortedList = new Array(52);
		this.leetFontMap=new Array();
		this.signatureFontMap=LeetkeyPreferenceLoaderLib.loadSignature();
		this.textLoop = null;
		this.bgcRgbOffsetRed = null;
		this.bgcRgbOffsetGreen = null;
		this.bgcRgbOffsetBlue = null;
		this.fgcRgbOffsetRed = null;
		this.fgcRgbOffsetGreen = null;
		this.fgcRgbOffsetBlue = null;
		this.textEditorRows = null;
		this.textEditorCols = null;

		this.getPreferenceBranch = LeetkeyPreferenceLoaderLib.getPreferenceBranch;
		this.getApplicationContainerType = LeetkeyPreferenceLoaderLib.getApplicationContainerType;

		this.getUnicodePref = LeetkeyPreferenceLoaderLib.getUnicodePref;
		this.loadPreferredKeyboardMap = LeetkeyPreferenceLoaderLib.loadPreferredKeyboardMap;
		this.loadPreferredKeyboardMap2 = LeetkeyPreferenceLoaderLib.loadPreferredKeyboardMap2;
		this.loadPreferredTextLoop = LeetkeyPreferenceLoaderLib.loadPreferredTextLoop;
		this.loadPreferredShortcuts = LeetkeyPreferenceLoaderLib.loadPreferredShortcuts;
		this.loadPreferredLeetFont = LeetkeyPreferenceLoaderLib.loadPreferredLeetFont;
		this.setShortcutKey = LeetkeyPreferenceLoaderLib.setShortcutKey;
		this.loadPreferences = LeetkeyPreferenceLoaderLib.loadPreferences;
		this.loadStrings = LeetkeyPreferenceLoaderLib.loadStrings;
		this.loadUpdatePreference = LeetkeyPreferenceLoaderLib.loadUpdatePreference;

		this.loadColorOffsets = LeetkeyPreferenceLoaderLib.loadColorOffsets;
		this.loadEditorDimensions = LeetkeyPreferenceLoaderLib.loadEditorDimensions;

		this.setUpdatePreference = LeetkeyPreferenceLoaderLib.setUpdatePreference;
		this.loadLeetKeyVersion = LeetkeyPreferenceLoaderLib.loadLeetKeyVersion;
		this.setLeetKeyVersion = LeetkeyPreferenceLoaderLib.setLeetKeyVersion;
		this.getNextUpdateCounterPreference = LeetkeyPreferenceLoaderLib.getNextUpdateCounterPreference;
		this.loadStatusBarIconPreference = LeetkeyPreferenceLoaderLib.loadStatusBarIconPreference;
	},



	LeetkeyPreferenceObserver : {
		prefs : undefined,
		leetKeyPrefLoader : null,
	
		register : function(prefsBranch, leetKeyPrefLoader) {
			this.prefs = prefsBranch.QueryInterface(Components.interfaces.nsIPrefBranchInternal);
			//this.prefs = prefsBranch.QueryInterface(Components.interfaces.nsIPrefBranch2);
			this.prefs.addObserver("", this, false);
			this.leetKeyPrefLoader = leetKeyPrefLoader;
		},

		unregister : function() {
			if (this.prefs) {
				this.prefs.removeObserver("", this);
			} else {
				throw "cannot unload preference observer.";
			}
		},
	
		observe : function(aSubject, aTopic, aData) {
			if(aTopic!="nsPref:changed") return;
			if (aData.search(/shortcuts/i) >= 0){
				this.leetKeyPrefLoader.loadPreferredShortcuts(this.prefs);
			} else if(aData.search(/KeyboardMap/i) >=0) {
				this.leetKeyPrefLoader.loadPreferredKeyboardMap(this.prefs);
			} else if(aData.search(/TextLoop/i) >=0) {
				this.leetKeyPrefLoader.loadPreferredTextLoop(this.prefs);
			} else if(aData.search(/rgb/i) >=0) {
				this.leetKeyPrefLoader.loadColorOffsets(this.prefs);
			} else if(aData.search(/rows/i) >=0) {
				this.leetKeyPrefLoader.loadEditorDimensions(this.prefs);
			} else if(aData.search(/cols/i) >=0) {
				this.leetKeyPrefLoader.loadEditorDimensions(this.prefs);
			} else if(aData.search(/statusbar/i) >=0) {
				this.leetKeyPrefLoader.loadStatusBarIconPreference(this.prefs);
			} else if(aData.search(/LeetFont/i) >=0) {
				this.leetKeyPrefLoader.loadPreferredLeetFont(this.prefs);
			}
		}
	},

	getApplicationContainerName : function() {
		var hostAppId;
		if("@mozilla.org/xre/app-info;1" in Components.classes) {
			// running under Mozilla 1.8 or later
			var id = Components.classes["@mozilla.org/xre/app-info;1"].getService(Components.interfaces.nsIXULAppInfo).ID;
			if(id == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}") {
				hostAppId = "FF";
			} else if(id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
				hostAppId = "TB";
			} else {
				// another app
			}	
		} else {
			try {
				var id = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefBranch).getCharPref("app.id");
				if(id == "{ec8030f7-c20a-464f-9b0e-13a3a9e97384}") {
					hostAppId = "FF";
				} else if(id == "{3550f703-e582-4d05-9a08-453d09bdfdc6}") {
					hostAppId = "TB";
				} else {
					// another app
				}
			} catch(e) {
				// very old version
				//dump(e);
			}
		}
		return hostAppId;
	},

	getApplicationContainerType : function() {
		var hostAppId = LeetkeyPreferenceLoaderLib.getApplicationContainerName();
		LeetkeyPreferenceLoaderLib.hostAppId=hostAppId;
		this.hostAppId=hostAppId;
	},

	getNextUpdateCounterPreference : function(prefBranch) {
		var counter = 0;
		try {
			counter = prefBranch.getIntPref("version.update.counter") + 1;
			if (counter>LeetkeyPreferenceLoaderLib.versionUpdateCounterRollover) counter = 0;
			prefBranch.setIntPref("version.update.counter", counter);
		} catch(e) {
			counter = 0;
			prefBranch.setIntPref("version.update.counter", counter);
		}
		this.updateVersionCounter = counter;
	},

	loadStatusBarIconPreference : function(prefBranch) {
		LeetkeyPreferenceLoaderLib.showIcon=prefBranch.getBoolPref("statusbar.showicon");
		LeetKey.updateStatusBar();
	},

	loadColorOffsets : function(prefBranch) {
		this.bgcRgbOffsetRed = prefBranch.getIntPref("editor.style.bgc-rgb-offset-red");
		this.bgcRgbOffsetGreen = prefBranch.getIntPref("editor.style.bgc-rgb-offset-green");
		this.bgcRgbOffsetBlue = prefBranch.getIntPref("editor.style.bgc-rgb-offset-blue");
		this.fgcRgbOffsetRed = prefBranch.getIntPref("editor.style.fgc-rgb-offset-red");
		this.fgcRgbOffsetGreen = prefBranch.getIntPref("editor.style.fgc-rgb-offset-green");
		this.fgcRgbOffsetBlue = prefBranch.getIntPref("editor.style.fgc-rgb-offset-blue");
		LK_TextNode.bgcOffsetRed = this.bgcRgbOffsetRed;
		LK_TextNode.bgcOffsetGreen = this.bgcRgbOffsetGreen;
		LK_TextNode.bgcOffsetBlue = this.bgcRgbOffsetBlue;
		LK_TextNode.fgcOffsetRed = this.fgcRgbOffsetRed;
		LK_TextNode.fgcOffsetGreen = this.fgcRgbOffsetGreen;
		LK_TextNode.fgcOffsetBlue = this.fgcRgbOffsetBlue;
	},

	loadEditorDimensions : function(prefBranch) {
		this.textEditorRows = prefBranch.getIntPref("editor.rows");
		this.textEditorCols = prefBranch.getIntPref("editor.cols");
	},

	loadUpdatePreference : function(prefBranch) {
		this.tryUpdating = prefBranch.getBoolPref("version.autoupdate");
	},

	setUpdatePreference : function(prefBranch, tryUpdating) {
		prefBranch.setBoolPref("version.autoupdate", tryUpdating);
		loadUpdatePreference(prefBranch);
	},

	loadLeetKeyVersion : function(prefBranch) {
		this.leetKeyVersion = prefBranch.getCharPref("version");
		LeetkeyPreferenceLoaderLib.leetKeyVersion = this.leetKeyVersion;
	},

	setLeetKeyVersion : function(prefBranch, version) {
		prefBranch.setCharPref("version", version);
		this.leetKeyVersion = version;
		LeetkeyPreferenceLoaderLib.leetKeyVersion = version;
	},

	loadPreferredShortcuts : function(prefBranch) {
		var myKeySet;
		if (this.hostAppId == "FF") {
			myKeySet=document.getElementById("mainKeyset");
		} else if (this.hostAppId=="TB") {
			myKeySet=document.getElementById("tasksKeys");
			// SPECIAL CASE FOR shortcut 29, or LeetKey Font.
			// I am disabling it in TB, because it doesn't support
			// MIDAS yet and there are NO textareas in TB to use this feature.
			if (prefBranch.getCharPref("shortcuts.29")!="") {
				prefBranch.setCharPref("shortcuts.29","");
			}
		} else {
			return;
		}
		this.shortCutString="";
		var index=0;
		for(i in myKeySet.childNodes) {
			var keyId = myKeySet.childNodes[i].id;
			if (keyId && keyId!=null && keyId.length && keyId.length>11 && keyId.substring(0,12)=="key-leetkey-") {
				var shortCutStr = null;
				try {
					shortCutStr = prefBranch.getCharPref("shortcuts." + index);
				} catch (e) {}
				if (shortCutStr!=null && shortCutStr!="") {
					var el=document.getElementById(keyId);
					el.setAttribute("disabled", true);
					var shortCutStrFormatted = LeetkeyPreferenceLoaderLib.setShortcutKey(shortCutStr, keyId);
					if (shortCutStrFormatted==null) {
						el.setAttribute("disabled", true);
						this.shortCutString += keyId + ":" + shortCutStrFormatted + " : ";
					} else {
						el.setAttribute("disabled", false);
					}
				}
				index++;
			}
		}
	},

	setShortcutKey : function(keyString, keyId) {
		keyString = keyString.toLowerCase();
		var found = keyString.match(/(vk_[A-Z0-9]+_[A-Z0-9]+)/i);
		if (!found) {
			found = keyString.match(/(vk_[A-Z0-9]+)/i);
		}
		if (!found) return null;
		var keyCode = found[0];
		var mods = "";
		keyString = keyString.replace(/ctrl/i, "control");
		var stdmods = new Array("accel", "alt", "control", "meta", "shift");
		for (var i = 0; i < stdmods.length; i++) {
			if (keyString.indexOf(stdmods[i]) >= 0)
				mods += (mods == "" ? "" : ", ") + stdmods[i];
		}
		var shortCutStrFormatted=null;
		var element = document.getElementById(keyId);
		if (element) {
			var key;
			if (keyCode.length == 4) {
				key = keyCode.substr(3);
				element.removeAttribute("keycode");
				element.setAttribute("key", key);
			} else {
				key = keyCode.toUpperCase();
				element.removeAttribute("key");
				element.setAttribute("keycode", key);
			}
			element.setAttribute("modifiers", mods);
			shortCutStrFormatted = mods +" "+ key;
		}
		return shortCutStrFormatted;
	},

	getUnicodePref: function (prefName,prefBranch) {
		return prefBranch.getComplexValue(prefName, Components.interfaces.nsISupportsString).data;
		//return prefBranch.getCharPref(prefName);
	},

	loadPreferredKeyboardMap2 : function(prefBranch) {
		var keyMap = new Array();
		var map = null;
		try {
			map = eval(this.getUnicodePref("KeyboardMap2Dim",prefBranch));
		} catch (e) {
			konsoleDump("Failed loading keyboard map: " + e);
			throw "TB";
		}
		for(i=0;i<map.length;i++) {
			keyMap[map[i][0]]=LK_toPrintableString2(map[i][1]);
		}
		return keyMap;
	},

	loadPreferredKeyboardMap : function(prefBranch) {
		var unsorted=new Array();
		this.leetKeyMap = this.loadPreferredKeyboardMap2(prefBranch);
		var index=0;
		for(i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var value=this.leetKeyMap[key];
			if (value!=null) {
				this.leetKeyStringMap[value]=key;
				unsorted[index++]=value;
			}
		}
		// sort list: two loops, first find the longest string, second collect all strings of that length.
		// this is way better than bubble sort.  In case of the default, 4 char, 3 char, 2 char, 1 char
		// strings, the number of full iterations is 10.  Bubbling would have been 127^3
		var sorted=new Array();
		var sortedIndex=0;
		while(sortedIndex<unsorted.length) {
			var longest=0;
			for(i=0;i<unsorted.length;i++) {
				var str=unsorted[i];
				if (str!=null && str.length>longest) {
					longest=str.length;
				}
			}
			//now we know the longest strings, grab them all at once.
			for(i=0;i<unsorted.length;i++) {
				var str=unsorted[i];
				if (str!=null && str.length==longest) {
					sorted[sortedIndex++]=str;
					unsorted[i]=null;
				}
			}
		}
		this.leetKeyStringSortedList=sorted;
	},

	loadPreferredTextLoop : function(prefBranch) {
		this.textLoop = LK_toPrintableString(prefBranch.getCharPref("TextLoop"));
	},

	loadPreferredLeetFont2 : function(prefBranch) {
		var fontMap = new Array();
		var map=null;
		try {
			map = eval(this.getUnicodePref("LeetFont",prefBranch));
		} catch (e) {
			konsoleDump("Failed loading font map: " + e);
		}
		for(i=0;i<map.length;i++) {
			if(map[i][0]=="<BCKSLSH>") {
				fontMap["\\"]=LK_toPrintableString2(map[i][1]);
			} else if(map[i][0]=="<DBLQT>") {
				fontMap["\""]=LK_toPrintableString2(map[i][1]);
			} else {
				fontMap[map[i][0]]=LK_toPrintableString2(map[i][1]);
			}
		}
		// always figure out height of chars by letter A.  Force
		// all characters to the same height.
		var h=0;
		var letA=fontMap["A"];
		for(var i=0;i<letA.length;i++) {
			if (letA.charAt(i)=='\n') {
				h++;
			}
		}
		fontMap["height"]=h;
		for(i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var value=fontMap[key];
			if (value!=null && typeof value!='object') {
				value=LeetkeyPreferenceLoaderLib.unpackString(value, h);
				fontMap[key]=value;
			}
		}
		return fontMap;
	},

	loadPreferredLeetFont : function(prefBranch) {
		var fontMap = LeetkeyPreferenceLoaderLib.loadPreferredLeetFont2(prefBranch);
		this.leetFontMap=fontMap;
	},


	getPreferenceBranch : function() {
		return Components.classes['@mozilla.org/preferences-service;1'].getService(Components.interfaces.nsIPrefService).getBranch("leetkey.");
	},

	loadPreferences : function() {
		var prefs = this.getPreferenceBranch();
		try {
			this.loadStatusBarIconPreference(prefs);
			this.loadUpdatePreference(prefs);
			this.getNextUpdateCounterPreference(prefs);
			this.loadLeetKeyVersion(prefs);
			this.loadPreferredShortcuts(prefs);
			this.loadPreferredKeyboardMap(prefs);
			this.loadPreferredTextLoop(prefs);
			this.loadColorOffsets(prefs);
			this.loadEditorDimensions(prefs);
			if (LeetkeyPreferenceLoaderLib.hostAppId!="TB") {
				this.loadPreferredLeetFont(prefs);
			}
		} catch(e) {
			konsoleDump("Error: " + e.message);
		}
		LeetkeyPreferenceLoaderLib.LeetkeyPreferenceObserver.register(prefs, this);
	},

	loadStrings : function() {
		this.leetKeyStrings = document.getElementById("LeetKeyStrings");
		var leetKeyLocalizationPrefs = Components.classes["@mozilla.org/preferences-service;1"].getService(Components.interfaces.nsIPrefService).getBranch("extensions.{3335F91D-2AEF-4097-B831-C96C60349822}.");
		var leetkeylocaledescription = this.leetKeyStrings.getString("leetkey-description");
		this.signatureFontMap["signature"]=this.leetKeyStrings.getString("signature");
		var str = Components.classes[ "@mozilla.org/supports-string;1" ].createInstance( Components.interfaces.nsISupportsString );
		str.data = leetkeylocaledescription;
		leetKeyLocalizationPrefs.setComplexValue( "description", Components.interfaces.nsISupportsString, str);
	},

	loadSignature : function() {
		var sigMap=new Array();
		sigMap["A"]="3 6*\n1 3*2 3*\n3*3 3*\n9*\n3*3 3*\n3*3 3*\n";
		sigMap["B"]="7*1 \n3*3 2*\n7*1 \n7*1 \n3*3 2*\n7*1 \n";
		sigMap["C"]="1 6*\n3*4 \n3*4 \n3*4 \n3*4 \n1 6*\n";
		sigMap["D"]="6*2 \n3*3 1*1 \n3*4 1*\n3*4 1*\n3*3 1*1 \n6*2 \n";
		sigMap["E"]="1 7*\n3*5 \n6*2 \n6*2 \n3*5 \n1 7*\n";
		sigMap["F"]="8*\n7*1 \n3*5 \n5*3 \n3*5 \n3*5 \n";
		sigMap["G"]="1 6*3 \n3*7 \n3*7 \n3*4 3*\n3*3 2*2 \n1 6*3 \n";
		sigMap["H"]="3*3 3*\n3*3 3*\n9*\n9*\n3*3 3*\n3*3 3*\n";
		sigMap["I"]="3*\n3*\n3*\n3*\n3*\n3*\n";
		sigMap["J"]="4 5*\n5 3*1 \n5 3*1 \n2*3 3*1 \n1 2*2 3*1 \n3 4*2 \n";
		sigMap["K"]="3*2 3*\n3*1 3*1 \n6*2 \n6*2 \n3*1 3*1 \n3*2 3*\n";
		sigMap["L"]="3*5 \n3*5 \n3*5 \n3*5 \n8*\n8*\n";
		sigMap["M"]="1 3*1 3*1 3*1 \n3*2 3*2 3*\n3*2 3*2 3*\n3*2 3*2 3*\n3*2 3*2 3*\n3*2 3*2 3*\n";
		sigMap["N"]="3*3 3*\n4*2 3*\n5*1 3*\n3*1 5*\n3*2 4*\n3*3 3*\n";
		sigMap["O"]="1 6*1 \n3*2 3*\n3*2 3*\n3*2 3*\n3*2 3*\n1 6*1 \n";
		sigMap["P"]="7*1 \n3*2 3*\n3*2 3*\n7*1 \n3*5 \n3*5 \n";
		sigMap["Q"]="1 6*2 \n3*2 3*1 \n3*2 3*1 \n3*2 3*1 \n3*2 4*\n1 7*1 \n";
		sigMap["R"]="7*1 \n3*2 3*\n3*2 3*\n7*1 \n3*2 3*\n3*2 3*\n";
		sigMap["S"]="1 7*2 \n3*7 \n1 4*5 \n5 4*1 \n7 3*\n2 7*1 \n";
		sigMap["T"]="9*\n9*\n3 3*3 \n3 3*3 \n3 3*3 \n3 3*3 \n";
		sigMap["U"]="3*3 3*\n3*3 3*\n3*3 3*\n3*3 3*\n1 8*\n2 7*\n";
		sigMap["V"]="3*3 3*\n3*3 3*\n3*3 3*\n3*3 3*\n1 3*1 3*1 \n3 3*3 \n";
		sigMap["W"]="3*3 3*3 3*\n3*3 3*3 3*\n3*3 3*3 3*\n3*3 3*3 3*\n1 3*1 2*1 2*1 3*1 \n3 3*3 3*3 \n";
		sigMap["X"]="3*3 3*\n1 3*1 3*1 \n2 5*2 \n2 5*2 \n1 3*1 3*1 \n3*3 3*\n";
		sigMap["Y"]="3*3 3*\n1 3*1 3*1 \n2 5*2 \n3 3*3 \n3 3*3 \n3 3*3 \n";
		sigMap["Z"]="9*\n9*\n4 3*2 \n2 3*4 \n9*\n9*\n";
		var h=0;
		var letA=sigMap["A"];
		for(var i=0;i<letA.length;i++) {
			if (letA.charAt(i)=='\n') {
				h++;
			}
		}
		sigMap["height"]=h;
		for(i=0;i<256;i++) {
			var key=String.fromCharCode(i);
			var value=sigMap[key];
			if (value!=null && typeof value!='object') {
				value=LeetkeyPreferenceLoaderLib.unpackString(value, h);
				sigMap[key]=value;
			}
		}
		return sigMap;
	},
	unpackString : function(str, h) {
		var outArray=new Array(h);
		var index=0;
		var out="";
		for(var y=0;y<str.length;y++) {
			var ch=str.charAt(y);
			var x=parseInt(ch);
			if (isNaN(x)) {
				if (ch=='\n') {
					outArray[index]=out;
					out="";
					index++;
				} else {
					out+=ch;
				}
			} else {
				y++;
				ch=str.charAt(y);
				for(k=0;k<x;k++) {
					out+=ch;
				}
			}
		}
		return outArray;
	}
}