// Leet Key extension for Mozilla Firefox
// Copyright (C) 2005  Roman Mironenko
// For licensing terms, please refer to readme.txt in this extension's XPInstall 
// package or its installation directory on your computer.

var leetKeyInit = null;

// for some unnatural reason trim function is not in ThunderBird.
String.prototype.trim = function() { return this.replace(/^\s+|\s+$/g, ""); };
String.prototype.reverse = function() {var s="";var i=this.length;while(i>0){s+=this.substring(i-1,i);i--;}return s;}


if (window) {
	window.addEventListener("load",function() {leetKeyInit = new LeetKeyInitializer.LeetKeyInitializer();} ,false);
	//window.addEventListener("focus",function() {leetKeyInit = new LeetKeyInitializer.LeetKeyInitializer();} ,false);
}

var LeetKey = {
	// INIT
	initializeLeetKey : function() {
		LK_TextEditorLib.initTextEditorLib();
		LeetKeyEditorHandlers.initDvorak();
		LeetKeyTransformerHandlers.initLeetKeyTransformerHandlers();
	},
	updateStatusBar : function() {
		if (leetKeyInit) {
			leetKeyInit.updateLeetKeyStatusBar();
		}
	},

	// EDITORS START
	createTabEditor : function() {
		LK_TextEditorLib.createNewBrowserTabEditor("LEET KEY EDITOR","lk_editor","lk_editor",leetKeyInit.prefLoader.textEditorCols,
			leetKeyInit.prefLoader.textEditorRows,"physical","LEET KEY EDITOR - you can type here.", true);
	},

	toggleLeet : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.mapLeet, true, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleReverseTyping : function() {
		LeetKeyStyleHandlers.toggleTextAlignStyle();
		//LeetKeyStyleHandlers.toggleReverseTypingStyle();
		var nodeType = LK_TextEditorLib.getNode();
		if (!nodeType.isNodeRichText) {
			var eventHandlerArray = new Array(1);
			eventHandlerArray[0] = new LK_TextEditorLib.EventTypeEventHandler("keypress", LeetKeyEditorHandlers.mapReverse);
			var textNode = LK_TextEditorLib.toggleEditor1(LK_TextEditorLib.onKeyReverseHandler, eventHandlerArray, false, true, false, false);
			//var textNode = LK_TextEditorLib.toggleEditor1(LK_TextEditorLib.onKeyReverseHandlerTranslateToStringNoEventOverriding, eventHandlerArray, false, true, false, false);
			leetKeyInit.updateLeetKeyStatusBar();
		}
	},

	toggleROT13 : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.ROT13, true, true);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleURLEncode : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.urlEncode, false, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleHEXEncode : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.encodeHex, false, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleBINEncode : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.binEncode, false, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleMorseEncode : function() {
		LK_TextEditorLib.toggleEditor(LeetKeyEditorHandlers.encodeMorse, false, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleMorseSpaceBar : function() {
		if (!LK_TextNode.TextNode.prototype.morseTypeStartMS) {
			LK_TextNode.TextNode.prototype.morseTypeStartMS = -1;
		}
		if (!LK_TextNode.TextNode.prototype.morseCharDelim) {
			LK_TextNode.TextNode.prototype.morseCharDelim = "";
		}
		var eventHandlerArray = new Array(3);
		eventHandlerArray[0] = new LK_TextEditorLib.EventTypeEventHandler("keyup", LeetKeyEditorHandlers.morseKeyUp);
		eventHandlerArray[1] = new LK_TextEditorLib.EventTypeEventHandler("keydown", LeetKeyEditorHandlers.morseKeyDown);
		eventHandlerArray[2] = new LK_TextEditorLib.EventTypeEventHandler("keypress", LeetKeyEditorHandlers.morseKeyPress);
		var textNode = LK_TextEditorLib.toggleEditor1(LK_TextEditorLib.onKeyHandlerTranslateToStringNoEventOverriding, eventHandlerArray, false, false, false, false);
		textNode.morseTypeStartMS = -1;
		textNode.morseCharDelim = "";
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleTextLoop : function() {
		if (!LK_TextNode.TextNode.prototype.textLoopIndex) {
			LK_TextNode.TextNode.prototype.textLoopIndex = 0;
		}
		var textNode = LK_TextEditorLib.toggleEditorProcessAllCharCodes(LeetKeyEditorHandlers.textLoop, false, false);
		textNode.textLoopIndex = 0;
		leetKeyInit.updateLeetKeyStatusBar();
	},

	toggleDvorak : function() {
		var textNode = LK_TextEditorLib.toggleEditorProcessAllCharCodes(LeetKeyEditorHandlers.dvorak, false, false);
		leetKeyInit.updateLeetKeyStatusBar();
	},

	turnLeetOff : function() {
		LeetKeyStyleHandlers.resetAllStyles();
		LK_TextEditorLib.turnOffAllEditors();
		leetKeyInit.updateLeetKeyStatusBar();
	},

	// TRANSFORMERS START
	executeLeet : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.transformToLeet, true, false);},
	executeLeetDecode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.transformFromLeet, true, false);},
	executeROT13 : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.rot13, true, false);},
	executeURLEncode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.urlEncode, true, false);},
	executeURLDecode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.urlDecode, true, false);},
	executeBase64Encode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.encodeBase64, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.encodeBase64, true, false);
		}
	},
	executeBase64Decode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.decodeBase64, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.decodeBase64, true, false);
		}
	},
	
	executeHEXEncode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.encodeHex, true, false);},
	executeHEXDecode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.decodeHex, true, false);},
	executeBINEncode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.binEncode, true, false);},
	executeBINDecode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.binDecode, true, false);},
	executeMorseEncode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.encodeMorse, true, false);},
	executeMorseDecode : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.decodeMorse, true, false);},
	executeTextLoop : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.textLoop, true, false);},
	executeToUpper : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.toUpper, true, false);},
	executeToLower : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.toLower, true, false);},
	executeCapitalize : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.capitalize, true, false);},
	executeReverseText : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.reverseText, true, false);},
	executeAESencode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.encodeAES, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.encodeAES, true, false);
		}
	},
	executeAESdecode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.decodeAES, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.decodeAES, true, false);
		}
	},
	executeDESencode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.encodeDES, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.encodeDES, true, false);
		}
	},
	executeDESdecode : function() {
		var nodeType = LK_TextEditorLib.getNode();
		var node = null;
		if (nodeType!=null) {
			node = nodeType.node;
		}
		var selection = LK_TextEditorLib.getSelection(node);
		if (selection!=null) {
			LK_TextEditorLib.transformHTMLSelectionAsSingleRange(selection, LeetKeyTransformerHandlers.decodeDES, false);
		} else {
			LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.decodeDES, true, false);
		}
	},
	executeSignature : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.transformToSig, true, false);},
	executeToLeetFont : function() {LK_TextEditorLib.transformSelectionText(LeetKeyTransformerHandlers.transformToLeetFont, false, false);}
}